<?php

/* message.php: Page for reading messages 
*
    Copyright (C) 2002  Hastymail Development group

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; Version 2
    See the COPYING file for complete information.

* $Id: message.php,v 1.261 2003/10/21 17:19:37 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'message');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
$hm_input['id'] = session_id();
$str = $_SESSION['str'];

if (isset($hm_input['destination'])) {
    $dest = $hm_input['destination'];
}
elseif (isset($_SESSION['move_to_destination'])) {
    $dest = $_SESSION['move_to_destination'];
}
else {
    $dest = 'INBOX';
}
$_SESSION['move_to_destination'] = $dest;

/* check for full header viewing status */
if (isset($hm_input['full']) && $hm_input['full'] == 'yes') {
    $hm_input['full'] = true;
    $_SESSION['full'] = 'yes';
}
elseif (isset($hm_input['full']) && $hm_input['full'] == 'no') {
    $hm_input['full'] = false;
    $_SESSION['full'] = false;
    unset($_SESSION['full']);
}
elseif (isset($_SESSION['full']) && $_SESSION['full'] == 'yes') {
    $hm_input['full'] = true;    
}
else {
    $hm_input['full'] = false;
}

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* check for simple option and set flag */
$simple = false;
if (isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true') {
    $simple = true;
}

/* get unseen info */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);

if (isset($hm_input['new']) && $hm_input['new'] == 1) {
    if (isset($unseen[urldecode($hm_input['mailbox'])])) {
        if ($unseen[urldecode($hm_input['mailbox'])] > 0) {
            $unseen[urldecode($hm_input['mailbox'])] -= 1;
        }
    }
}

/* select the mailbox for imap */
hm_select_mailbox($imap_stream, $hm_input['mailbox']);
$cache = hm_check_cache($hm_input['mailbox']);

/* check if we can use the cache */

/* get sort information */
if (!isset($hm_input['page_num'])) {
    $hm_input['page_num'] = '0';
}
if (isset($_SESSION['settings']['sort']) 
          && array_key_exists($hm_input['mailbox'], $_SESSION['settings']['sort'])) {
    $sort = $_SESSION['settings']['sort'][$hm_input['mailbox']];
} 
else {
    $sort = 'ARRIVAL';
}
if ($cache) {
    $sort_info = $_SESSION['sort_data'][$hm_input['mailbox']];
}
else {
    $sort_info = hmw_get_sort_info($imap_stream, $sort, $hm_input['mailbox']);
}

/* process move and delete actions */
$action_dsp = "";
if (isset($hm_input['action'])) {
    $dest = false;
    $action_uid = false;
    if (isset($hm_input['destination'])) {
        $dest = $hm_input['destination'];
    }
    if ($hm_input['action'] == $str[4]) {
        $action_uid = $hm_input['uid_delete'];
    }
    elseif ($hm_input['action'] == $str[0]) {
        $action_uid = $hm_input['uid_move'];
    }
    if ($action_uid) {
    $result = hm_message_controls($hm_input['action'], $imap_stream,
              $action_uid, $dest, false, false, $hm_input['mailbox'], 
              1, $str[26]);
    $action_dsp = $result[0];
    $err_flag = $result[1]; 
    }   
    if (isset($_SESSION['thread_data'][$hm_input['mailbox']])) {
        unset($_SESSION['thread_data'][$hm_input['mailbox']]);
    }
    $sort_info = hm_get_sort_info($imap_stream, $sort, $hm_input['mailbox']);
}

/* bail if the message is gone */
if (!in_array($hm_input['uid'], $sort_info[2])) {
    $_SESSION['del_error'] = "Could not open requested message.";
    if (isset($hm_input['search']) && $hm_input['search'] == 1) {
        $_SESSION['del_error'] .= 
                        '<br>'.$str[216].'<br>'.$str[217];
        header("Location: ".$config['hostname'].$config['install_path'].
           "search.php?id=".$hm_input['id']."&mailbox=".$hm_input['mailbox']);
        exit;
        
    }
    else {
        $_SESSION['del_error'] .= 
                        '<br>'.$str[218];
        header("Location: ".$config['hostname'].$config['install_path'].
           "mailbox.php?id=".$hm_input['id']."&mailbox=".$hm_input['mailbox']);
        exit;
    }
}


/* toolbar and any status messages */
hm_toolbar($imap_stream, $hm_input['mailbox'], $unseen, false, $str[26].' '.$str[9]);

/* get message structure */
$structure = hm_get_struct($imap_stream, $hm_input['uid']);

/* check for drafts */
$draft = false;
if (isset($_SESSION['settings']['drafts_folder']) && urldecode($hm_input['mailbox']) ==
    $_SESSION['settings']['drafts_folder']) {
    $tmp = hm_get_messages($hm_input['uid'], $imap_stream);
    $flags = $tmp[$hm_input['uid']][5];
    if (stristr($flags, 'draft')) {
        $draft = true;
    }
}
/* default is to search for a part, otherwise get the requested part */
if (!isset($hm_input['part'])) {
    $results = hm_find_display_part($imap_stream, $structure, $hm_input['uid']);
    $hm_input['top_level'] = $results[0];
    if ($results[1] == "\n\n     ".$str[194]."\n\n" && 
        $structure[1]['type'].$structure[1]['subtype'] == 'texthtml' &&
        isset($_SESSION['settings']['html_only']) &&
        $_SESSION['settings']['html_only'] == 'true') {
        $results = hm_find_display_part($imap_stream, $structure, $hm_input['uid'], 1);
    }
}
else {
    $results = hm_find_display_part($imap_stream, $structure, $hm_input['uid'], 
                                    $hm_input['part']);
    /* not 100% of the time, so fix this at some point! :)*/
    $hm_input['top_level'] = 1;
}

$hm_input['part']= $results[0];
$text_part = $results[1];
$decode = $results[2][0];
$type = $results[2][1];
$subtype = $results[2][2];
$dsp_type = $results[2][3];
if (isset($results[2][5]) && $results[2][5]) {
    $name = $results[2][5];
}

$code_page = false;
$charset_convert = false;
$charset = false;
$utf = false;
if (isset($results[2][4]) && $results[2][4] && $str['charset'] == 'UTF-8') {
    $charset = strtolower($results[2][4]);
    if (isset($_SESSION['charsets'][$charset])) {
        $code_page = $_SESSION['charsets'][$charset];
        $charset_convert = true;
    }
}
if ($charset == 'utf-8') {
    $utf = true;
}
$message_headers = hm_get_full_header($imap_stream, $hm_input['uid'], false, true);
$subject = $str[229];
if (isset($message_headers['subject']) && $message_headers['subject'] != '') {
    $subject = $message_headers['subject'];
}
$date = $str[231];
if (isset($message_headers['date']) && $message_headers['date'] != '') {
    $date = date("g:i a, F j, Y",(strtotime($message_headers['date'])));
}
$from = $str[230];
if (isset($message_headers['from']) && $message_headers['from'] != '') {
    $from = $message_headers['from'];
}
$to = $str[232];
if (isset($message_headers['to']) && $message_headers['to'] != '') {
    $to = $message_headers['to'];
}
$cc = false;
if (isset($message_headers['cc']) && $message_headers['cc'] != '') {
    $cc = $message_headers['cc'];
}
$xmailer = false;
if (isset($message_headers['x-mailer']) && $message_headers['x-mailer'] != '') {
    $xmailer = $message_headers['x-mailer'];
}
elseif (isset($message_headers['user-agent']) && $message_headers['user-agent'] != '') {
    $xmailer = $message_headers['user-agent'];
}

/* check for mailing list header */
$message_list_reply = false;
if (isset($message_headers['list-post'])) {
    if (preg_match("/&lt;mailto:(.+)&gt;/i", $message_headers['list-post'], $matches)) {
        $message_list_reply = true;
        $message_list_reply_to = $matches[1]; 
    }
}
elseif (isset($message_headers['x-list-post'])) {
    if (preg_match("/&lt;mailto:(.+)&gt;/i", $message_headers['x-list-post'], $matches)) {
        $message_list_reply = true;
        $message_list_reply_to = $matches[1]; 
    }
}
elseif (isset($message_headers['x-mailing-list'])) {
    if (preg_match("/([^\s]+@[^\s]+)/i", $message_headers['x-mailing-list'], $matches)) {
        $message_list_reply = true;
        if (isset($matches[1])) {
            $message_list_reply_to = $matches[1]; 
        }
        else {
            $message_list_reply_to = '';
        }
    }
}

/* message display */
$smaller = false;
if (isset($hm_input['reply_notice']) || $action_dsp != '' || 
    isset($hm_input['bounce_notice']) ||
    (isset($hm_input['search']) && $hm_input['search'] == 1) ||
    (isset($hm_input['thread']) && $hm_input['thread'] == 1)) {
    $smaller = true;
}
$message_dsp_result = hm_message_header ($sort_info, $hm_input['mailbox'], $imap_stream,
                                         $hm_input['page_num'], $hm_input['id'], 
                                         $hm_input['uid'], $_SESSION['dsp_folders'], 
                                         $smaller, $simple);

$message_dsp_header = $message_dsp_result[0];
$prev_flag = $message_dsp_result[1];
$next_flag = $message_dsp_result[2];
if ($message_dsp_result[3]) {
    $prev_new = $message_dsp_result[3];
    $font_type1 = 'font3';
}
else {
    $prev_new = 0;
    $font_type1 = 'font2';
}
if ($message_dsp_result[4]) {
    $next_new = $message_dsp_result[4];
    $font_type2 = 'font3';
}
else {
    $next_new = 0;
    $font_type2 = 'font2';
}

/* display reply/delete/move message notices */
if (!$simple) {
    echo '<table width="95%" align="center" cellpadding="4" cellspacing="4"',
         ' class="tables5">
   <tr>
      <td align="center" colspan="3">
      <table width="100%" cellpadding="6" cellspacing="4">',"\n",$message_dsp_header,'
            </td>';
    if (isset($hm_input['reply_notice'])) {
        hm_imap_action($imap_stream, $hm_input['uid'], 'ANSWERED');
        echo '      <td align="center" nowrap class="tables3" width="10%">
      <font class="font2"><small>
      ',$str[42],'
      </small></font>
      </td>
      <td align="center" nowrap class="tables1" width="30%">
      &nbsp;
      </td>',"\n";
    }
    elseif (isset($hm_input['bounce_notice'])) {
        echo '      <td align="center" nowrap class="tables3" width="10%">
      <font class="font2"><small>',"\n";
        if ($hm_input['bounce_notice'] == 'yes') {
            echo $str[223];
        }
        else {
            echo $str[224];
        }     
        echo '      </small></font>
      </td>
      <td align="center" nowrap class="tables1" width="30%">
      &nbsp;
      </td>',"\n";
    }
    elseif ($action_dsp != '') {
            echo '      <td align="center" nowrap class="tables3" width="10%">
      <font class="font2"><small>
      ',$action_dsp,'
      </small></font>
      </td>
      <td align="center" nowrap class="tables1" width="30%">
      &nbsp;
      </td>',"\n";
    }
    /* prev/next/back links for search results */
    elseif (isset($hm_input['search']) && $hm_input['search'] == 1) {
        $search_result = $_SESSION['search_info'];
        $folders_index = array_keys($search_result);
        $folder_index_array = array_keys($folders_index, $hm_input['mailbox']);
        $fold_pos = $folder_index_array[0];
        $fold_max = (count($folders_index) - 1);
        $current_box_result = array_keys($search_result[$hm_input['mailbox']]);
        $max = (count($current_box_result) - 1);
        $search_index_array = array_keys($current_box_result, $hm_input['uid']);
        $pos = $search_index_array[0];
        if (!stristr($search_result[$hm_input['mailbox']][$current_box_result[$pos]][5],
            'seen')) {
            $_SESSION['search_info'][$hm_input['mailbox']][$current_box_result[$pos]][5]
                .= ' seen';
        } 
        echo '      <td align="center" nowrap class="tables3" width="10%">',"\n";
        $font = 'font2';
        $new = 0;
        if ($pos > 0) {
            if (!stristr($search_result[$hm_input['mailbox']]
                [$current_box_result[($pos - 1)]][5], 'seen')) {
                $font = 'font3';
                $new = 1;
            }
            echo '     <small><a class="',$font,'" href="message.php?id=',$hm_input['id'],
             '&amp;uid=',$current_box_result[($pos - 1)],'&amp;mailbox=',
             $hm_input['mailbox'],'&amp;search=1&amp;new=',$new,
             '">&lt;&lt;&lt;</a></small>',"\n";
             $font = 'font2';
             $new = 0;
        }
        elseif ($fold_pos > 0) {
            $new_folder = $folders_index[($fold_pos - 1)];
            $new_folder_index = array_keys($search_result[$new_folder]);
            $new_uid = $new_folder_index[(count($new_folder_index) - 1)];
            if (!stristr($search_result[$new_folder][$new_uid][5], 'seen')) {
                $font = 'font3';
                $new = 1;
            }
            echo '     <small><a class="',$font,'" href="message.php?id=',$hm_input['id'],
             '&amp;uid=',$new_uid,'&amp;mailbox=',$new_folder,
             '&amp;search=1&amp;new=',$new,'">&lt;&lt;&lt;</a></small>',"\n";
             $font = 'font2';
             $new = 0;
        }
        echo '      <small><a class="font2" href="search.php?mailbox=',
      urlencode($hm_input['mailbox']),'&amp;uid=',$hm_input['uid'],
      '&amp;id=',urlencode($hm_input['id']),'">
      Back to Search
      </a></small>',"\n";
        if ($pos < $max) {
            if (!stristr($search_result[$hm_input['mailbox']]
                [$current_box_result[($pos + 1)]][5], 'seen')) {
                $font = 'font3';
                $new = 1;
            }
            echo '     <small><a class="',$font,'" href="message.php?id=',$hm_input['id'],
             '&amp;uid=',$current_box_result[($pos + 1)],'&amp;mailbox=',
             $hm_input['mailbox'],'&amp;search=1&amp;new=',$new,
             '">&gt;&gt;&gt;</a></small>',"\n";
             $font = 'font2';
             $new = 0;
        }
        elseif ($fold_pos < $fold_max) {
            $new_folder = $folders_index[($fold_pos + 1)];
            $new_folder_index = array_keys($search_result[$new_folder]);
            $new_uid = $new_folder_index[0];
            if (!stristr($search_result[$new_folder][$new_uid][5], 'seen')) {
            $font = 'font3';
            $new = 1;
            }
            echo '     <small><a class="',$font,'" href="message.php?id=',$hm_input['id'],
             '&amp;uid=',$new_uid,'&amp;mailbox=',$new_folder,
             '&amp;search=1&amp;new=',$new,'">&gt;&gt;&gt;</a></small>',"\n";
            $font = 'font3';
            $new = 1;
        }
        echo '      </td>
      <td align="center" nowrap class="tables1" width="30%">
      &nbsp;
      </td>',"\n";
    }

    /* prev/next/back links for thread results */
    elseif (isset($hm_input['thread']) && $hm_input['thread'] == 1) {
        $thread_range = false;
        if (is_array($_SESSION['thread_data'][$hm_input['mailbox']])) {
            foreach($_SESSION['thread_data'][$hm_input['mailbox']] as $index => $array) {
                if (in_array($hm_input['uid'], $array[1])) {
                    $thread_range = $array[1];
                }
            }
        }
        if ($thread_range) {
            $thread_index_array = array_keys($thread_range, $hm_input['uid']);
            $max = (count($thread_range) - 1);
            $pos = $thread_index_array[0];
        }
        else {
            $pos = 0;
            $max = 0;
        }
        echo '      <td align="center" nowrap class="tables3" width="10%">',"\n";
        if ($pos > 0) {
            echo '      <small><a class="font2" href="message.php?id=',$hm_input['id'],
             '&amp;uid=',$thread_range[($pos - 1)],'&amp;mailbox=',$hm_input['mailbox'],
             '&amp;thread=1">&lt;&lt;&lt;</a></small>',"\n";
        }
        echo '      <small><a class="font2" href="thread_view.php?mailbox=',
             urlencode($hm_input['mailbox']),
      '&amp;id=',urlencode($hm_input['id']),'&amp;uid=',$hm_input['uid'],'">
      Back to Thread
      </a></small>',"\n";
        if ($pos < $max) {
            echo '      <small><a class="font2" href="message.php?id=',$hm_input['id'],
             '&amp;uid=',$thread_range[($pos + 1)],'&amp;mailbox=',$hm_input['mailbox'],
             '&amp;thread=1">&gt;&gt;&gt;</a></small>',"\n";
        }
        echo '      </td>
      <td align="center" nowrap class="tables1" width="30%">
      &nbsp;
      </td>',"\n";
    }
    echo '            <td class="tables4" align="center" width="10%" nowrap>
            <small>',"\n";
}
/* prev/next/delete links */
if ($prev_flag) {
    echo  '            <a class="',$font_type1,'" href="message.php?mailbox=',
      urlencode($hm_input['mailbox']),'&amp;id=',$hm_input['id'],'&amp;page_num=',
      $hm_input['page_num'],'&amp;uid=',$prev_flag,'&amp;new=',$prev_new,
      '&amp;uid_delete=',$hm_input['uid'],'&amp;action=',$str[4],'">
            <<<
            </a>',"\n";
}
echo '            <a class="font2" href="mailbox.php?mailbox=',
     urlencode($hm_input['mailbox']),'&amp;id=',$hm_input['id'], '&amp;page_num=',
     $hm_input['page_num'],'&amp;uid_delete=',$hm_input['uid'],'&amp;action=',$str[4],'">
            ',$str[4],'
            </a>',"\n";
if ($next_flag) {
    echo '            <a class="',$font_type2.'" href="message.php?',
         'mailbox=',urlencode($hm_input['mailbox']),'&amp;id=',$hm_input['id'],
         '&amp;uid=',$next_flag,'&amp;new=',$next_new,'&amp;page_num=',
         $hm_input['page_num'],'&amp;uid_delete=',$hm_input['uid'],'&amp;action=',
         $str[4],'">
            >>>
            </a>',"\n";
}
if ($simple) {
    echo '&nbsp;&nbsp;&nbsp;';
}
else {
    echo '            </small>
            </td>
         </tr>
      </table>
      </td>
   </tr>
   <tr>',"\n";
    /* full/small header links */
    echo '      <td class="tables3" nowrap colspan="2">',"\n";
}
if ($hm_input['full']) {
    echo '      &nbsp;<small><a class="font2" href="message.php?',
       'uid=',$hm_input['uid'],'&amp;id=',$hm_input['id'],
       '&amp;mailbox=',urlencode($hm_input['mailbox']),'&amp;part=',$hm_input['part'],
       '&amp;full=no&amp;page_num=',$hm_input['page_num'],'">
      ',$str[30],'</a> &nbsp;&nbsp;&nbsp;</small>',"\n";
}
else {
    echo '      &nbsp;<small><a class="font2" href="message.php?',
       'uid=',$hm_input['uid'],'&amp;id=',$hm_input['id'],'&amp;mailbox=',
       urlencode($hm_input['mailbox']),'&amp;part=',$hm_input['part'],
       '&amp;full=yes','&amp;page_num=',$hm_input['page_num'],'">
      ',$str[29],'</a> &nbsp;&nbsp;&nbsp;</small>',"\n";
}
if ($simple) {
    echo '<br>';
}
if (!$simple) {
    /* raw/normal message links */
    if (isset($hm_input['raw']) && $hm_input['raw'] == 1) {
        echo '      <small>
      <a class="font2" href="message.php?id=',$hm_input['id'],
       '&amp;part=1&amp;uid=',$hm_input['uid'],'&amp;mailbox=',
       urlencode($hm_input['mailbox']),'">
      ',$str[32],'</a> &nbsp;&nbsp;&nbsp;</small>',"\n";
    }
    else {    
        echo '      <small>
      <a class="font2" href="message.php?id=',$hm_input['id'],
       '&amp;raw=1&amp;part=1&amp;uid=',$hm_input['uid'],'&amp;mailbox=',
       urlencode($hm_input['mailbox']),'">
      ',$str[31],'</a> &nbsp;&nbsp;&nbsp;</small>',"\n";
    }

    /* thread view */
    if ((isset($_SESSION['config']['client_sort']) && $_SESSION['config']['client_sort']
        == 'false') || !isset($_SESSION['config']['client_sort'])) {
        echo '      <small>
      <a class="font2" href="thread_view.php?id=',$hm_input['id'],
       '&amp;uid=',$hm_input['uid'],'&amp;mailbox=',urlencode($hm_input['mailbox']),'">
      ',$str[33],'</a> &nbsp;&nbsp;&nbsp;</small>';
    }

    /* print view */
    if (isset($hm_input['part_full']) && $hm_input['part_full'] == 'yes') {
        $print_part_full = '&amp;print_part_full=true';
    }
    else {
        $print_part_full = '';
    }

    if (isset($hm_input['full']) && $hm_input['full'] == 'yes') {
        $print_full = '&amp;print_full=true';
    }
    else {
        $print_full = '';
    }
    echo '      <small>
      <a class="font2" href="print_view.php?id=',$hm_input['id'],
       '&amp;part=',$hm_input['part'],'&amp;uid=',$hm_input['uid'],
       '&amp;mailbox=',urlencode($hm_input['mailbox']),$print_part_full,
       $print_full,'">
      ',$str[34],'</a></small> &nbsp;&nbsp;
      </td>
      <td align="center" class="tables1" nowrap width="10%">',"\n";

    /* form for moving messages */
    if ($next_flag) {
        $form_action = 'message.php';
    }
    else {
        $form_action = 'mailbox.php';
    }
    echo '
      <form action="',$form_action,'" method="post">
      <input type=submit name="action" class="button2" value="',$str[0],'">--&gt;
      <input type="hidden" name="id" value="',$hm_input['id'],'">
      <input type="hidden" name="mailbox" value="',
      urldecode($hm_input['mailbox']),'">
      <input type="hidden" name="uid_move" value="',$hm_input['uid'],'">
      <select class="select3" name="destination">',"\n";
    hm_folder_options($dest, false, $simple, false, 'class="option3"');
    echo "      </select>&nbsp;\n";
    if ($next_flag) {
        echo '      <input type="hidden" name="uid" value="',$next_flag,"\">\n";
    }
    echo '      </form>
      </td>
   </tr>
   <tr>
      <td class="tables3" colspan="3">
      <table width="100%" cellpadding="1" cellspacing="1">
          <tr>',"\n";

}
else {
    echo '<center>',$action_dsp,'</center>';
}

/* full headers */
if ($hm_input['full']) {
    $headers = hm_get_full_header($imap_stream, $hm_input['uid'], false, false);    
    $headers = hm_text_cleanup($headers, false, true);
    $headers = hm_special_chars($headers, $str['charset'], $charset_convert,
                                $code_page, $utf);
    if (!$simple) {
        echo '            <td width="100%">';
    }
    echo '            <small>
           ',str_replace(array(' ', "\n", "\t"), 
                         array('&nbsp;', '<br>', '&nbsp;&nbsp;'), $headers),'
            </small>';
    if (!$simple) {
        echo '            </td>
         </tr>',"\n";
    }
}

/* small headers */
else {
    if (!$simple) {
        echo '            <td>
            <table cellpadding="1" cellspacing="2">
               <tr>
                  <td valign="top">
                  <b>',$str[21],':&nbsp;&nbsp;</b>
                  </td>
                  <td valign="top">
                  ',$subject,'
                  </td>
               </tr>
               <tr>
                  <td valign="top">
                  <b>',$str[22],':</b>
                  </td>
                  <td valign="top">
                  ',str_replace('&quot;', '', $from),'
                  </td>
               </tr>
               <tr>
                  <td valign="top">
                  <b>',$str[23],':</b>
                  </td>
                  <td valign="top">
                  ',hm_special_chars($date, $str['charset'], $charset_convert, 
                                     $code_page, $utf),'
                  </td>
               </tr>
               <tr>
                  <td valign="top">
                  <b>',$str[25],':</b>
                  </td>
                  <td valign="top">',"\n";
    }
    else {
        echo $str[21],': ',$subject,
             '<br>',$str[22],': ',
             $from,'<br>',$str[23],': ',
             hm_special_chars($date, $str['charset'], $charset_convert, $code_page,
                              $utf),'<br>',
             $str[25],': ';
    }
    if (strlen($to) > 200) {
        echo '                   ',substr($to, 0, 200), "...\n";
    }
    else {
        echo '                   ',$to,
             "\n";
    }
    if (!$simple) {
        echo '                  </td>
               </tr>',"\n";
    }
    if ($cc) {
        if (!$simple) {
            echo '               <tr>
                  <td valign="top">
                  <b>',$str[87],':</b>
                  </td>
                  <td valign="top">',"\n";
        }
        if (strlen($cc) > 200) {
            echo '                   ',substr($cc, 0, 200), "...\n";
        }
        else {
            echo '                   ',$cc,
                 "\n";
        }
        if (!$simple) {
            echo '                  </td>
               </tr>',"\n";
        }
    }
    if ($xmailer) {
        if (!$simple) {
            echo '               <tr>
                  <td valign="top">
                  <b>Client:</b>
                  </td>
                  <td valign="top">',"\n";
        }
        echo '                   ',$xmailer,
                 "\n";
        if (!$simple) {
            echo '                  </td>
               </tr>',"\n";
        }
    }
    if (!$simple) {
        echo '            </table>
            </td>
         </tr>',"\n";
    }
}
if (!$simple) {
    echo '       </table>
       </td>
   </tr>
   <tr>',"\n";
}
else {
    echo '<br>';
}
/* reply | reply all | reply to list | forward links */
if (!$simple) {
    echo '      <td class="tables3" nowrap colspan="3">',"\n";
}
echo '      &nbsp;<small>
      <a class="font2" href="compose.php?id=',$hm_input['id'],'&amp;reply=1',
         '&amp;part=',$hm_input['top_level'],'&amp;uid=',$hm_input['uid'],
         '&amp;mailbox=',urlencode($hm_input['mailbox']),'">
      ',$str[35],'</a>&nbsp;&nbsp;&nbsp;</small>',"\n";
echo '      <small>
      <a class="font2" href="compose.php?id=',$hm_input['id'],
      '&amp;reply=1&amp;all=1&amp;part=',$hm_input['top_level'],
      '&amp;uid=',$hm_input['uid'],'&amp;mailbox=',urlencode($hm_input['mailbox']),'">
      ',$str[36],'</a>&nbsp;&nbsp;&nbsp;</small>',"\n";
if ($message_list_reply) {
    echo '      <small>
      <a class="font2" href="compose.php?id=',$hm_input['id'],
       '&amp;reply=1&amp;list_reply=',urlencode($message_list_reply_to),
       '&amp;part=',$hm_input['top_level'],'&amp;uid=',$hm_input['uid'],
       '&amp;mailbox=',urlencode($hm_input['mailbox']),'">
      ',$str[40],'</a>&nbsp;&nbsp;&nbsp;</small>',"\n";
}
echo '      <small>
      <a class="font2" href="compose.php?id=',$hm_input['id'],
       '&amp;forward=1&amp;part=',$hm_input['top_level'],'&amp;uid=',$hm_input['uid'],
       '&amp;mailbox=',urlencode($hm_input['mailbox']),'">
      ',$str[37],'</a>&nbsp;&nbsp;&nbsp;</small>
      <small>
      <a class="font2" href="compose.php?id=',$hm_input['id'],
       '&amp;bounce=1&amp;part=',$hm_input['top_level'],'&amp;uid=',$hm_input['uid'],
       '&amp;mailbox=',urlencode($hm_input['mailbox']),'">
      ',$str[222],'</a>&nbsp;&nbsp;&nbsp;</small>',"\n";
if ($draft) {
    echo '      <small>
      <a class="font2" href="compose.php?id=',$hm_input['id'],
       '&amp;draft=1&amp;uid=',$hm_input['uid'],'&amp;mailbox=',
       urlencode($hm_input['mailbox']),'">
      ',$str[247],'</a>&nbsp;&nbsp;&nbsp;</small>',"\n";
}
if (!$simple) {
    echo '      </td>
   </tr>
   <tr>
      <td class="tables3" colspan="3">',"\n";
}

/* check for rfc header information on nested parts */
$part_decode = false;
if (strstr($hm_input['part'], '.') && array_key_exists(1, $structure)) {
    $part_decode = true;
    $value = hm_in_multi_array($hm_input['part'], $structure, array(), true); 
    $part_headers = hm_get_full_header($imap_stream, $hm_input['uid'], $value[0], true);
    if (!isset($part_headers['content-type'])) {
        $part_headers['content-type'] = '';
    }
    $part_code_page = false;
    $part_charset_convert = false;
    $part_charset = false;
    $part_utf = false;
    if ($part_charset = strstr(strtolower($part_headers['content-type']), 'charset')) {
        if ($str['charset'] == 'UTF-8') {
            $part_charset = substr(strstr($part_charset, '='), 1);
            $part_charset = substr($part_charset, 0, strcspn($part_charset, ' '));
            $part_charset = str_replace(array('"', ';'), '', $part_charset);
            $part_charset = trim($part_charset);
            if (isset($_SESSION['charsets'][$part_charset])) {
                $part_code_page = $_SESSION['charsets'][$part_charset];
                $part_charset_convert = true;
            }
        }
    }
    if ($charset == 'utf-8') {
        $part_utf = true;
    }
   
    /* check for mailing list header */
    if (isset($part_headers['list-post'])) {
        if (preg_match("/<mailto:([^>]+)>/i", $part_headers['list-post'], $matches)) {
            $list_reply = true;
            $list_reply_to = $matches[1]; 
        }
    }
    elseif (isset($part_headers['x-list-post'])) {
        if (preg_match("/<mailto:([^>]+)>/i", $part_headers['x-list-post'], $matches)) {
            $list_reply = true;
            $list_reply_to = $matches[1]; 
        }
    }
    else {
        $list_reply = false;
    }

/* rfc message headers */
    if (is_array($part_headers)) {
        $feilds = array ('subject', 'from', 'date');
        if (isset($hm_input['part_full']) && !$simple) { 
            $part_full_view = 'yes';
            echo '      <table cellpadding="1" cellspacing="1">',"\n";
            foreach ($part_headers as $key => $value) {
                echo '         <tr>
            <td colspan="2">
            <small>&nbsp;',$key,
            ': ',$value,'</small><br>
            </td>
        </tr>',"\n";
            }
        }
        else {
            if (!$simple) {
                echo '      <table cellpadding="1" cellspacing="1">
         <tr>
            <td>
            <small><b>&nbsp;&nbsp;&nbsp;',$str[21],':&nbsp;&nbsp;</b></small>
            </td>
            <td>
            <small>',$part_headers['subject'],'</small>
            </td>
        </tr>
        <tr>
            <td>
            <small><b>&nbsp;&nbsp;&nbsp;',$str[22],':</b></small>
            </td>
            <td>
            <small>',$part_headers['from'],'
            </small>
            </td>
        </tr>
         <tr>
            <td>
            <small><b>&nbsp;&nbsp;&nbsp;',$str[23],':</b></small>
            </td>
            <td>
            <small>',date("g:i a, F j, Y",( strtotime($part_headers['date']))),'
            </small>
            </td>
        </tr>',"\n";
            }
            else {
                echo '<br>',$str[21],': ',$part_headers['subject'],$str['charset'], 
                     '<br>',$str[22],': ',$part_headers['from'],'<br>Date: ',
                     date("g:i a, F j, Y",(strtotime($part_headers['date']))),
                     "<br>\n";
            }
        }
        if (!$simple) {
            echo '      </table>
      </td>
   </tr>
   <tr>
      <td class="tables3" colspan="3">
      <table width="100%" cellpadding="1" cellspacing="1">
         <tr>
            <td nowrap colspan="3">&nbsp;',"\n";
        }
        /* full/small/reply/list reply/forward links for rfc part */
        if (isset($hm_input['part_full']) && !$simple) {
            echo '            <small><a class="font2" href="message.php?',
                 'uid=',$hm_input['uid'],'&amp;id=',$hm_input['id'],
                 '&amp;part=',$hm_input['part'],'&amp;mailbox=',
                 urlencode($hm_input['mailbox']),'&amp;page_num=',
                 $hm_input['page_num'],'">',$str[30],'</a>&nbsp;&nbsp;</small>',"\n";
        }
        elseif (!$simple) {
            echo '            <small><a class="font2" href="message.php?uid=',
                 $hm_input['uid'],'&amp;id=',$hm_input['id'],'&amp;part=',
                 $hm_input['part'],'&amp;mailbox=',urlencode($hm_input['mailbox']),
                 '&amp;part_full=yes&amp;page_num=',$hm_input['page_num'],
                 '">',$str[29],'</a>&nbsp;&nbsp;</small>',"\n";
        }
        echo '            <small><a class="font2" href="compose.php?id=',$hm_input['id'],
            '&amp;reply=1&amp;part=',$hm_input['part'],'&amp;uid=',$hm_input['uid'],
            '&amp;mailbox=',urlencode($hm_input['mailbox']),'">
            ',$str[41],'</a>&nbsp;&nbsp;</small>',"\n";
        echo '            <small><a class="font2" href="compose.php?id=',$hm_input['id'],
            '&amp;reply=1&amp;all=1&amp;part=',$hm_input['part'],'&amp;uid=',
            $hm_input['uid'],'&amp;mailbox=',urlencode($hm_input['mailbox']),'">
            ',$str[36],'</a>&nbsp;&nbsp;</small>',"\n";
        if ($list_reply) {
        echo '            <small><a class="font2" href="compose.php?id=',$hm_input['id'],
            '&amp;reply=1&amp;list_reply=',urlencode($list_reply_to),
            '&amp;part=',$hm_input['part'],'&amp;uid=',$hm_input['uid'],
            '&amp;mailbox=',urlencode($hm_input['mailbox']),'">
            ',$str[40],'</a>&nbsp;&nbsp;</small>',"\n";
        }
        echo '            <small>
            <a class="font2" href="compose.php?id=',$hm_input['id'],'&amp;forward=1',
            '&amp;part=',$hm_input['part'],'&amp;uid=',$hm_input['uid'],
            '&amp;mailbox=',urlencode($hm_input['mailbox']),'">
            ',$str[225],'</a>&nbsp;&nbsp;</small>',"\n";
        if (!$simple) {
            echo '            <small>
            </td>
         </tr>
      </table>
      </td>
   </tr>
   <tr>
      <td class="tables3" colspan="3">',"\n";
        } 
    }
}

/* search headers and body for email addresses */
$test_headers = array();
foreach ($message_headers as $index => $value) {
    switch (true) {
        case preg_match('/^received/', $index):
        case $index == 'message-id':
        case $index == 'resent-message-id':
        case $index == 'references':
        case $index == 'in-reply-to':
            break;
        default:
            $test_headers[] = $value;
            break;
    }
}
if (isset($part_headers)) {
    $test_part_headers = array();
    foreach ($part_headers as $index => $value) {
        switch (true) {
            case preg_match('/^received/', $index):
            case $index == 'message-id':
            case $index == 'resent-message-id':
            case $index == 'references':
            case $index == 'in-reply-to':
                break;
            default:
                $test_part_headers[] = $value;
                break;
        }
    }
    $part_string = implode(' ', $test_part_headers);
}
else {
    $part_string = '';
}
$test_string = implode(' ', $test_headers).' '.$part_string;
if (substr($dsp_type, 0, 4) == 'text') {
    $test_string .= ' '.$text_part;
}
if (preg_match_all("/([\.\-\_[:alnum:]]+@[\.\-\_[:alnum:]]{2,}\.[[:alnum:]]{2,})/i", 
                   $test_string, $matches)) {
    if (isset($matches[1])) {
        $get_addresses = array_unique($matches[1]);
    }
    else {
        $get_addresses = array();
    }
}
if ($part_decode) {
    $message_charset_convert = $part_charset_convert;
    $message_code_page = $part_code_page;
    $message_utf = $part_utf;
    $message_charset = $part_charset;
}
else {
    $message_charset_convert = $charset_convert;
    $message_code_page = $code_page;
    $message_utf = $utf;
    $message_charset = $charset;
}

/* if the selected message part is an image we can display */
if (substr($dsp_type, 0, 5) == 'image') {
    echo '      <br><center><img src="download.php?id=',$hm_input['id'],
         '&amp;mailbox=',$hm_input['mailbox'],
         '&amp;uid=',$hm_input['uid'],
         '&amp;part=',$hm_input['part'],
         '&amp;decode=',$decode,
         '&amp;type=',$type,
         '&amp;subtype=',$subtype,
         '&amp;name=',$name,'" alt="',$name,'"></center><br>',"\n";
}

/* if raw message view is selected */
elseif (isset($hm_input['raw']) && $hm_input['raw'] == 1) {
    $text_part = hm_get_message_part($imap_stream, $hm_input['uid'], 'raw');
    echo '      <table width="97%" align="center">
          <tr>
             <td>
             <pre>',hm_special_chars($text_part, $str['charset'], 
                                     $message_charset_convert, $message_code_page,
                                     $message_utf),'</pre>
             </td>
         </tr>
      </table>',"\n";
}

/* if the selected part is an HTML part */
elseif ($dsp_type == 'texthtml') {
    require_once('../filter/filter.php');
    $level = 1;
    if (isset($_SESSION['settings']['filter_level']) &&
        is_numeric($_SESSION['settings']['filter_level'])) {
        $level = $_SESSION['settings']['filter_level'];
    }
    $clean = hm_filter_html($text_part, $level);
    if ($message_charset_convert) {
        $clean = hm_utf8_convert($clean, $message_code_page);
    }
    elseif ($str['charset'] == 'UTF-8') {
        if ((isset($message_charset) && $message_charset != 'utf-8') ||
           (isset($message_headers['content-type']) && 
           !stristr(strtolower($message_headers['content-type']), 'utf-8'))) {
            $clean = utf8_encode($clean);
        }
    }
    /* if no html tags are found in the message aside from the 
       start and stop sanitized html tags inserted by the filter
       then format this as a text part and display as text */

    if (substr_count($clean, "<") < 3) {
        $clean = "\n<pre>\n".hm_text_cleanup($clean)."\n</pre>\n";
    } 
    echo '      <table width="97%" align="center">
         <tr>
             <td>
             ',$clean,'<br>
             </td>
         </tr>
      </table>',"\n";
}

/* if the selected part is a text part */
elseif ($dsp_type == 'textplain')  {
    if (isset($_SESSION['settings']['font_type'])) {
        $font_type = $_SESSION['settings']['font_type'];
    }
    else {
        $font_type = 'monospace';
    }
    $text_part = hm_special_chars($text_part, $str['charset'], $message_charset_convert,
                                  $message_code_page, $message_utf);
    $lines = split("\n", $text_part);
    $text_part = '';
    $last_line = '';

    /* add reply quoting color */
    foreach ($lines as $line) {
        $reply_test = substr(ltrim($line), 0, 4);
        if ($reply_test == '&gt;' || $last_line == "\\" || substr($line, 0, 1) == '|') {
            $line = "<font\tstyle=\"{font-family:\t".$font_type.
                    ";\tcolor:\t#555555}\">".$line."</font><br>\n";
            $last_line = substr($line, -1, 1);
        }
        else {
            $line = $line."<br>\n";
            $last_line = '';
        }
        $line = str_replace('&gt;', ' &gt;', $line);
        $text_part .= $line;
    }

    /* add clickable (http|ftp)s links */
    if (isset($_SESSION['settings']['click_links']) &&
        $_SESSION['settings']['click_links'] == 'true') {
        $text_part = preg_replace("/((http|ftp)s?:\/\/(%[[:digit:]A-Fa-f][[:digit:]A-Fa-f]|[-_\.!~\*';\/\?#:@&=\+$,[:alnum:]])+)/",
                    "<a\ttarget=\"_new\"\thref=\"\\1\">\\1</a>",
                    $text_part);
    }
    $text_part = str_replace(' &gt;', '&gt;', $text_part);

    /* add clickable email addresses */
    if (isset($_SESSION['settings']['click_email']) &&
        $_SESSION['settings']['click_email'] == 'true') {
        $text_part = preg_replace("/([\w\.\-]+@[a-zA-Z0-9\-]+(\.[a-zA-Z0-9\-]{1,})*(\.[a-zA-Z]{2,3}){1,2})/",
                 "<a\thref=\"compose.php?id=".$hm_input['id']."&amp;to=\\1\">\\1</a>", 
                 $text_part);
    }
    $text_part = str_replace(' ', '&nbsp;', $text_part);

    echo '      <table width="97%">
         <tr>
            <td nowrap width="1%">
            &nbsp;
            </td>
            <td style="{font-family: ',$font_type,'}">

            <!-- Message text -->

            ',$text_part,'

            <!-- End of message text -->

            </td>
         </tr>
      </table>',"\n";
}

/* hmm... not displayable */
elseif (!$simple) {
    echo '      <table width="97%" align="center">
         <tr>
            <td>
            </td>
         </tr>
      </table>',"\n";
}

/* message attachments display */
if (!isset($hm_input['raw'])) {
    if (!$simple) {
        echo '      </td>
   </tr>
   <tr>
      <td  class="tables3" colspan="3">
      <table width="100%" align="center">
         <tr class="tables0">
            <td align="center" colspan="5">
            ',$str[46],'
            </td>
         </tr>
         <tr>
            <td align="center" colspan="2" width="30%">
            <small><b>',$str[44],'</b></small>
            </td>
            <td align="center" width="60%">
            <small><b>',$str[45],'</b></small>
            </td>
            <td align="center" width="10%">
            <small><b>',$str[24],'</b></small>
            </td>
         </tr>',"\n";
    }
    else {
        echo '&nbsp;&nbsp;',$str[46],"\n";
    }
    $atag ='<a class="font2" href="message.php?uid='.$hm_input['uid'].
           '&amp;id='.$hm_input['id'].'&amp;mailbox='.urlencode($hm_input['mailbox']).
           '&amp;page_num='.$hm_input['page_num']."&amp;";
    hm_print_attachments($structure, $hm_input['part'], $atag);
    if (!$simple) {
        echo '      </table>
      </td>
   </tr>',"\n";
    }
}

/* add to addressbook option */
if (!empty($get_addresses) && !$simple) {
echo '   <tr>
   <td align="center" colspan="3">
   <table width="100%" cellpadding="3" cellspacing="4">
   ',$message_dsp_header,'
         </td>
         <td nowrap class="tables1" align="right">
         <form action="contacts.php" method="post">
         <input type="hidden" name="id" value="',$hm_input['id'],'">
         <input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'\">
         &nbsp;<input type="submit" value="',$str[43],'" name="prep" class="button2">
         <select name="prep_addy">',"\n";
    foreach ($get_addresses as $addy) {
        echo '              <option value="',hm_special_chars($addy, $str['charset'],
             $charset_convert, $code_page, $utf),"\">", 
             hm_special_chars($addy, $str['charset'], $charset_convert, 
                              $code_page, $utf),
             "</option>\n";
    }
    echo '         </select>
         </form>',"\n";
}
elseif (!$simple) {
echo '   <tr>
      <td align="center" colspan="3">
      <table width="100%" cellpadding="6" cellspacing="4">
      ',$message_dsp_header,'
            </td>
            <td class="tables1" width="60%">&nbsp;',"\n";
}
else {
    echo '<br>',$message_dsp_header;
}
if (!$simple) {
    echo '            </td>
         </tr>
      </table>
      </td>
   </tr>
</table>',"\n";
}
echo '
</body>
</html>';
hm_imap_logout($imap_stream); 

?>
