<?php

/* new.php: Displays new mail from all folders 
*
    Copyright (C) 2002  Hastymail Development group

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; Version 2
    See the COPYING file for complete information.

* $Id: new.php,v 1.78 2003/10/21 18:16:43 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'new');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
$hm_input['id'] = session_id();
$str = $_SESSION['str'];

if (isset($hm_input['destination'])) {
    $dest = $hm_input['destination'];
}
elseif (isset($_SESSION['move_to_destination'])) {
    $dest = $_SESSION['move_to_destination'];
}
else {
    $dest = 'INBOX';
}
$_SESSION['move_to_destination'] = $dest;


/* check for simple option and set flag */
$simple = false;
if (isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true') {
    $simple = true;
}

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* if we don't have the folder list in the session, get it */
$dsp_folders = $_SESSION['dsp_folders'];

$errs = array();
$action_dsp = '';
if (isset($hm_input['action'])) {
    $total = 0; 
    if ($hm_input['selection_type'] == 'page') {
        $sel = false;
        $array = $_SESSION['new_data'];
    }
    elseif ($hm_input['selection_type'] == 'marked') {
        $array = $_POST;
        $sel = true;
    }
    elseif (isset($hm_input['selection_type'])) {
        if (isset($_SESSION['new_data']) && array_key_exists($hm_input['selection_type'], 
            $_SESSION['new_data'])) {
            $array = array($hm_input['selection_type'] => 
                           $_SESSION['new_data'][$hm_input['selection_type']]);
            $sel = false;
        }
    }
    foreach ($array as $name => $value) {
            if ($sel) {
                $name = base64_decode($name);
            }
        if (substr($name, 0, 5) == 'fold_' || !$sel) {
            if ($sel) {
                $fold = substr($name, 5);
            }
            else {
                $fold = $name;
            }
            $dsp_count = count($value);
            $dsp_end = '';
            $dest = false;
            if (isset($hm_input['destination'])) {
                $dest = $hm_input['destination'];
            }
            if ($sel) {    
                $uid_string = $value[0];
                if ($dsp_count > 1) {
                    $uid_string = implode(',', $value);
                }
            }
            else {
                $uids = array_keys($value);
                $uid_string = $uids[0]; 
                if ($dsp_count > 1) {
                    $uid_string = implode(',', $uids);
                }
            }
            hm_select_mailbox($imap_stream, $fold);
            $result = hm_message_controls ($hm_input['action'], $imap_stream,
                                           $uid_string, $dest, false, false, $fold, 
                                           $dsp_count, $dsp_end);
            $action_dsp = $result[0];
            $err_flag = $result[1];
            if ($err_flag) {
                $errs[] = $action_dsp;
            }
            $total += $dsp_count;
        }
    }
    if ($total > 1 && empty($errs)) {
        $action_dsp = preg_replace("/\d+/", $total.' messages', $action_dsp);
    }
    else {
        $action_dsp = preg_replace("/\d+/", $total.' message', $action_dsp);
    }
        
}

/* get unseen messages */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);

/* sort function */
function date_cmp ($a, $b) {
    if ($a[10] == $b[10]) {
        return 1;
    }
    elseif ($a[10] < $b[10]) {
        return 1;
    }
    else {
        return -1;
    }
}

/* get headers for unseen messages */
$data = array();
$total_unseen = 0;
$total_unseen_folders = 0;
foreach ($unseen as $folder => $new_count) {
    if ($new_count > 0) {
        $total_unseen_folders++;
        $total_unseen += $new_count;
        hm_select_mailbox($imap_stream, $folder);
        $uid_list = hm_search_mailbox($imap_stream, 'SEARCH UNSEEN');
        $uid_list = str_replace(' ', ',', trim($uid_list));
        $headers = hm_get_messages($uid_list, $imap_stream);
        uasort($headers, "date_cmp");
        $data[$folder] = $headers; 
    }
}

/* toolbar */
hm_toolbar($imap_stream, $hm_input['mailbox'], $unseen, true, $str[10].' '.$str[9]);

if (!empty($errs)) {
    echo '<table>';
    foreach($errs as $val) {
        echo '   <tr>
      <td align="center" class="tables3">
      <font color="red"><small>',$val,'</small></font>
      </td>
   </tr>',"\n";
    }
    echo ' </table>',"\n";
}

if (count($data) > 0) {
    echo '<br>
<form action="new.php" method="post">',"\n";
    if (!$simple) {
        echo '<table width="98%" align="center" cellpadding="4" cellspacing="4">
   <tr>
      <td nowrap width="30%" align="center" class="tables1">
      <b>',$total_unseen,'</b> ',$str[50],' <b>',$total_unseen_folders,
      '</b> ',$str[125],'
      </td>',"\n";
        if ($action_dsp != '') {
            echo '      <td align="center" width="20%" class="tables3">
      <font class="font2"><small>',$action_dsp,'</small></font>
      </td>
      <td width="50%" align="right" colspan="2" class="tables1" nowrap>',"\n";
        }
        else {
            echo '     <td width="70%" align="right" colspan="2" class="tables1" nowrap>',
             "\n";
        }
    }
    else {
        echo $action_dsp,'   ';
    }
    echo '      <input class="button4" type="submit" name="toggle_all" ', 
         'value="',$str[246],'">&nbsp;&nbsp;
      <input type="hidden" name="id" value="',$hm_input['id'],'">
      <input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'">
      &nbsp;&nbsp;<select name="selection_type" class="select3">
          <option class="option3" value="marked">',$str[6],'</option>';
    if (!empty($data)) {
        $fold_tmp = array_keys($data);
        $fold_tmp_dsp = hm_folder_dsp($fold_tmp);
        foreach ($fold_tmp as $val) {
            echo '<option class="option3" value="',$val,'">',$str[51],' ',
                 $fold_tmp_dsp[$val], '</option>',"\n";
        }
    }
    echo '          <option class="option3" value="page">',$str[52],'</option>
      </select>&nbsp;
      <input type="submit" class="button4" name="action" value="',$str[2],'">
      <input type="submit" class="button4" name="action" value="',$str[3],'">
      <input type="submit" class="button4" name="action" value="',$str[4],'">
      &nbsp;<input type="submit" class="button4" name="action" value="',$str[1],'">-<input type="submit" class="button4" name="action" value="',$str[0],'">--&gt;
      <select class="select3" name="destination">',"\n";
    hm_folder_options($dest, false, $simple, false, 'class="option3"');
    echo '      </select>&nbsp;&nbsp;',"\n";
    if (!$simple) {
        echo '
      </td>
   </tr>
   <tr>
      <td>
      </td>
   </tr> 
   <tr class="tables0">
      <td colspan="4">
      <table width="99%" align="center" cellpadding="1" cellspacing="0" class="tables5">
      <tr class="tables0">
      <td width="50%" align="center">
      <small>
      ',$str[21],'
      </small>
      </td>
      <td width="30%" align="center">
      <small>
      ',$str[22],'
      </small>
      </td>
      <td align="center" width="15%">
      <small>
      ',$str[23],'
      </small>
      </td>
      <td align="center" width="5%">
      <small>
      ',$str[24],'
      </small>
      </td>
      <td class="tables0">
      </td>
   </tr>', "\n";
    }
    else {
        echo '<table>';
    }
    foreach($data as $folder => $uid_array) {
        echo '         <tr>
            <td colspan="4">',"\n";
            if (!$simple) {
                echo '            <table cellpadding="1" cellspacing="0" width="100%">
               <tr>
                  <td width="20%" nowrap>
                  &nbsp;',"\n";
            }
            else {
                echo '<tr><td>';
            }
            echo '                  <a class="font2" href="mailbox.php?mailbox=',
                  urlencode($folder),
                  '&amp;id=',$hm_input['id'],'">
                  <b><small>',htmlspecialchars($dsp_folders[$folder], ENT_QUOTES,
                  $str['charset']),'
                  </small></b>
                  </a>
                  <font class="font2"><small><small>
                  &nbsp;(',$unseen[$folder],')&nbsp;
                  </small></small></font>',"\n";
        if (!$simple) {
            echo '                  </td>
                  <td class="tables5">
                  </td>
               </tr>
            </table>
            </td>
            <td class="tables0">
            </td>
         </tr>',"\n";
        }
        else {
            echo '</td></tr>';
        }
        $chk_folder = base64_encode('fold_'.$folder);
        foreach ($uid_array as $uid => $headers) {
            if (!isset($headers[0]) || trim($headers[0]) == '') {
                $subject = $str[229];
            }
            else {
                $subject = $headers[0];
            }
            if (!isset($headers[1]) || trim($headers[1]) == '') {
                $from = $str[230]; 
            }
            else {
                $headers[1] = ltrim(str_replace('&quot;', '', $headers[1]));
                if (substr($headers[1], 0, 4) != '&lt;') {
                    $headers[1] = preg_replace("/&lt;.*&gt;/", '', $headers[1]);
                }
                else {
                    $headers[1] = str_replace(array('&lt;', '&gt;'), '', $headers[1]);
                }
                $from = $headers[1];
            }
            if (!isset($headers[2]) || trim($headers[2]) == '') {
                $headers[2] = $str[231];
            }
            if (isset($headers[7])) {
                $size = $headers[7];
            }
            else {
                $size = '';
            }
            if (isset($headers[4]) && (stristr($headers[4], 'multipart') || 
                stristr($headers[4], 'mixed'))) {
                $headers[4] = "<b><small>&nbsp;+</small></b>\n";
            }
            else {
                $headers[4] = '';
            }
            $tag = 'uid='.$uid.'&amp;mailbox='.urlencode($folder).'&amp;id='.
                   urlencode($hm_input['id']).'&amp;new=1';
            if (!$simple) {
                echo '          <tr class="tables3">
             <td width="50%" class="tables2">
             <table width="100%" cellpadding="0" cellspacing="0">
                <tr>
                   <td width="1%" nowrap>
                   <input type="checkbox" name="',$chk_folder,'[]" value="',$uid,'" ';
                if (isset($hm_input['toggle_all'])) {
                    if (!isset($_POST[$chk_folder])) {
                        echo 'CHECKED ';
                    }
                    else {
                        if (!in_array($uid, $_POST[$chk_folder])) {
                            echo 'CHECKED ';
                        }
                    }
                }
                echo '>&nbsp;
                   </td>
                   <td>
                   <small><a class="font1" href="message.php?',$tag,'">
                   ',$subject,'
                   </a> </small>
                   </td>
                </tr>
             </table>
             </td>
             <td width="30%" class="tables2">
             <small><a class="font1" href="message.php?',$tag,'">
             ',$from,'
             </a></small>
             </td>
             <td width="15%" class="tables2" nowrap>
             <small><a class="font1" href="message.php?',$tag,'">
             &nbsp;',htmlspecialchars($headers[2], ENT_QUOTES, $str['charset']),'
             </a></small>
             </td>
             <td class="tables2" width="5%" align="center" nowrap>';
            if ($size != '') {
                $kb = intval($size/1024);
                if ($kb < 1) {
                    echo $size," b\n";
                }
                elseif ($kb > 1000) {
                    echo intval($kb/1024)," mb\n";
                }
                else {
                    echo $kb," kb\n";
                }
            }
            echo '             </td>
            <td class="tables0" align="center">
             ',$headers[4],'
            </td>
         </tr>',"\n";
            }
            else {
                echo '<tr><td>
             <input type="checkbox" name="',$chk_folder,'[]" value="',$uid,'">&nbsp;
             <a class="font1" href="message.php?',$tag,'">
             ',$headers[0],'</a>','&nbsp;&nbsp;',$headers[1],'&nbsp;&nbsp;',
             $headers[2],
             '</td></tr>';
            }
        }
    }
    if (!$simple) {
        echo '         <tr>
            <td class="tables0" colspan="5">
            &nbsp;
            </td>
         </tr>
      </table>
      </td>
   </tr>
</table>';
    }
    else {
        echo '</table>';
    }
}
else {
    echo '</table>
<br><table align="center" class="tables3">
   <tr>
      <td align="center">
      <font class="font2"><small>
      ',$str[53],'
      </small></font>
      </td>
   </tr>
</table>',"\n";
}

echo '</form>
</body>
</html>';

$_SESSION['new_data'] = $data;
hm_imap_logout($imap_stream); 

?>
