<?php

/* search.php: Interface for searching mailboxes
*
    Copyright (C) 2002  Hastymail Development group

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; Version 2
    See the COPYING file for complete information.

* $Id: search.php,v 1.43 2003/10/21 18:16:43 sailfrog Exp $
*/

require_once('../lib/wrapper_functions.php');

/* collect and validate incoming vars */
$hm_input = hm_validate_input($_POST, $_GET, 'search');

/* set ini values and check/get the SESSION vars */
if (hm_session_continue($hm_input['id'], $config_file)) {
    $config = $_SESSION['config'];
}
$hm_input['id'] = session_id();
$str = $_SESSION['str'];

if (isset($hm_input['destination'])) {
    $dest = $hm_input['destination'];
}
elseif (isset($_SESSION['move_to_destination'])) {
    $dest = $_SESSION['move_to_destination'];
}
else {
    $dest = 'INBOX';
}
$_SESSION['move_to_destination'] = $dest;

if (isset($_SESSION['settings']['simple']) && $_SESSION['settings']['simple'] == 'true') {
    $simple = $_SESSION['settings']['simple'];
}
else {
    $simple = false;
}

/* login to imap */
if (!$imap_stream = hm_imap_login($_SESSION['user'], $_SESSION['pass'], $config,
                                  $hasty_key, false, false)) {
    hm_logged_out($config_file);
}

/* get unseen messages */
$unseen = hm_unseen_status ($imap_stream, $_SESSION['folders']);

/* toolbar */
hm_toolbar($imap_stream, $hm_input['mailbox'], $unseen, false, $str[11].' '.$str[9]);

/* check for error message */
if (isset($_SESSION['del_error']) && $_SESSION['del_error'] != '') {
    echo '<br><table align="center" class="tables3">
   <tr>
     <td align="center">
     ',$_SESSION['del_error'],'
      </td>
   </tr>
</table>',"\n";
    $_SESSION['del_error'] = '';
    unset($_SESSION['del_error']);
}

/* do message control actions */
$errs = array();
$action_dsp = '';
if (isset($hm_input['action'])) {
    $total = 0; 
    if ($hm_input['selection_type'] == 'page') {
        $sel = false;
        $array = $_SESSION['search_info'];
    }
    elseif ($hm_input['selection_type'] == 'marked') {
        $array = $_POST;
        $sel = true;
    }
    elseif (isset($hm_input['selection_type'])) {
        if (isset($_SESSION['search_info']) && 
            array_key_exists($hm_input['selection_type'], $_SESSION['search_info'])) {
            $array = array($hm_input['selection_type'] => 
                           $_SESSION['search_info'][$hm_input['selection_type']]);
            $sel = false;
        }
    }
    foreach ($array as $name => $value) {
            if ($sel) {
                $name = base64_decode($name);
            }
        if (substr($name, 0, 5) == 'fold_' || !$sel) {
            if ($sel) {
                $fold = substr($name, 5);
            }
            else {
                $fold = $name;
            }
            $dsp_count = count($value);
            $dsp_end = '';
            $dest = false;
            if (isset($hm_input['destination'])) {
                $dest = $hm_input['destination'];
            }
            if ($sel) {    
                $uid_string = $value[0];
                if ($dsp_count > 1) {
                    $uid_string = implode(',', $value);
                }
            }
            else {
                $uids = array_keys($value);
                $uid_string = $uids[0]; 
                if ($dsp_count > 1) {
                    $uid_string = implode(',', $uids);
                }
            }
            hm_select_mailbox($imap_stream, $fold);
            $result = hm_message_controls ($hm_input['action'], $imap_stream,
                                           $uid_string, $dest, false, false, $fold, 
                                           $dsp_count, $dsp_end);
            $action_dsp = $result[0];
            $err_flag = $result[1];
            if ($err_flag) {
                $errs[] = $action_dsp;
            }
            $total += $dsp_count;
        }
    }
    if ($total > 1 && empty($errs)) {
        $action_dsp = preg_replace("/\d+/", $total.' messages', $action_dsp);
    }
    else {
        $action_dsp = preg_replace("/\d+/", $total.' message', $action_dsp);
    }
    $hm_input['submit'] = $str[61];        
}


/* check the session and reset buttons */
if (isset($hm_input['submit']) && $hm_input['submit'] == $str[60]) {
    if (isset($_SESSION['search_params'])) {
        $_SESSION['search_params'] = array();
        unset($_SESSION['search_params']);
        unset($_SESSION['search_info']);
    }
    foreach($hm_input as $key => $value) {
        if (substr($key, 0, 4) == 'FLAG') {
            unset($hm_input[$key]);
        }
    }
}

$new_search = false;
$old_search = false;

/* execute the submitted search */
if (isset($hm_input['submit']) && ($hm_input['submit'] == $str[11] ||
    $hm_input['submit'] == $str[61])) {

    $range_type  = $hm_input['range_type'];
    $day         = $hm_input['day'];
    $month       = $hm_input['month'];
    $year        = $hm_input['year'];
    $size        = $hm_input['size'];
    $size_unit   = $hm_input['size_unit'];
    $search_part = $hm_input['search_part'];
    $sstring     = $hm_input['sstring'];
    $size_type   = $hm_input['size_type'];
    $search_folder = array();
    $_SESSION['search_params'] = $hm_input;
    unset($_SESSION['search_params']['mailbox']);
    unset($_SESSION['search_params']['id']);
    function date_cmp ($a, $b) {
        if ($a[10] == $b[10]) {
            return 1;
        }
        elseif ($a[10] < $b[10]) {
            return 1;
        }
        else {
            return -1;
        }
    }
    $date_string = '';
    $size_string = '';
    $flag_string = '';

        /* check which folders to search */
        $search_folder = array();
        if (!isset($hm_input['search_folders'])) {
            $search_folder[] = 'INBOX';
        }
        elseif (is_array($hm_input['search_folders']) && 
                !empty($hm_input['search_folders'])) {
            $search_folder = $hm_input['search_folders'];
        }
        else {
            $search_folder[] = 'INBOX';
        }
        $_SESSION['search_params']['search_folder'] = $search_folder;
    
        /* size options */
        if (isset($hm_input['size_type']) && $hm_input['size_type'] != 'any'
            && isset($hm_input['size']) && $hm_input['size'] > 0) {
            $size_string = $hm_input['size_type'].' ';
            switch ($hm_input['size_unit']) {
                case 'b':
                    $size_string .= $hm_input['size'];
                    break;
                case 'k';
                    $size_string .= $hm_input['size']*1024;
                    break;
                case 'm';
                    $size_string .= $hm_input['size']*1048576;
                    break;
            }
        }
    
        /* date range options */
        if (isset($hm_input['range_type']) && $hm_input['range_type'] != 'any') {
            $date_string = $hm_input['range_type'].' '.$hm_input['day'].'-'.
                           $hm_input['month'].'-'.$hm_input['year'];    
        }
    
        /* look for flag options */
        foreach ($hm_input as $key => $val) {
            if (substr($key, 0, 4) == 'FLAG') {
                $flag_string .= substr($key, 5).' ';
            }
        }
        $flag_string = rtrim($flag_string);
        if (isset($hm_input['sstring']) && $hm_input['sstring'] != '') {
            $spart = $hm_input['search_part'];
            $string = $hm_input['sstring'];
        }
        else {
            $spart = '';
            $string = false;
        }
        $search_string = 'SEARCH '.$flag_string.' '.$date_string.' '.$size_string.' '
                         .$spart;
        $search_string = preg_replace("/\s{2,}/", ' ', $search_string);
        if (rtrim($search_string) == 'SEARCH') {
            $search_string .= 'ALL';
        }
        $data = array();
        $f_cnt = 0;
        $ht_cnt = 0;
        foreach($search_folder as $sf) {
            $f_cnt++;
            hm_select_mailbox($imap_stream, $sf);
            $uids = hm_search_mailbox($imap_stream, $search_string, $string);
            $uids = str_replace(' ', ',', trim($uids));
            $headers = hm_get_messages($uids, $imap_stream);
            if (!empty($headers)) {
                $ht_cnt += count($headers);
                uasort($headers, "date_cmp");
                $data[$sf] = $headers;
            }
        }
        $_SESSION['search_info'] = $data;
        $_SESSION['search_params']['search_string'] = $search_string;
        $_SESSION['search_params']['ht_cnt'] = $ht_cnt;
        $_SESSION['search_params']['f_cnt'] = $f_cnt;
        $new_search = true;
}
elseif (isset($_SESSION['search_params']) && !empty($_SESSION['search_params']) &&
        isset($_SESSION['search_info'])) {
    foreach ($_SESSION['search_params'] as $key => $value) {
        if (substr($key, 0, 4) == 'FLAG') {
            $hm_input[$key] = $value;
        }
    }
    $range_type    = $_SESSION['search_params']['range_type'];
    $day           = $_SESSION['search_params']['day'];
    $month         = $_SESSION['search_params']['month'];
    $year          = $_SESSION['search_params']['year'];
    $size          = $_SESSION['search_params']['size'];
    $size_unit     = $_SESSION['search_params']['size_unit'];
    $search_part   = $_SESSION['search_params']['search_part'];
    $sstring       = $_SESSION['search_params']['sstring'];
    $size_type     = $_SESSION['search_params']['size_type'];
    $search_folder = $_SESSION['search_params']['search_folder'];
    $data          = $_SESSION['search_info'];
    $search_string = $_SESSION['search_params']['search_string'];
    $ht_cnt        = $_SESSION['search_params']['ht_cnt'];
    $f_cnt         = $_SESSION['search_params']['f_cnt'];
    $old_search    = true;
}
else {
    $range_type  = 'any';
    $day         = '1'; 
    $month       = 'Jan';
    $year        = '1970';
    $size        = '';
    $size_unit   = 'b';
    $search_part = 'TEXT';
    $sstring     = '';
    $size_type   = 'any';
    $search_folder = array();
}
echo '<form action="search.php" method="post">',"\n";
if ($new_search || $old_search) {
    echo '<br>
<table align="center" class="tables3" cellpadding="2" cellspacing="2">',"\n";
if ($old_search) {
    echo '   <tr>
      <td align="center" colspan="2">
      <font class="font2">
      <small>',$str[90],'</small>
      </font>
      </td>
   </tr>',"\n";
}
echo '   <tr>
      <td>
      &nbsp;',$str[63],'
      </td>
      <td>
      <small>',$search_string,' ',htmlspecialchars($sstring, ENT_QUOTES, $str['charset']),
     '&nbsp;</small>
      </td>
   </tr>
   <tr>
      <td>
      &nbsp;<small>',$str[64],'</small>
      </td>
      <td align="center">
      <small>',$ht_cnt,'</small>
      </td>
   </tr>
   <tr>
      <td>
      &nbsp;<small>',$str[65],'</small>
      </td>
      <td align="center">
      <small>',$f_cnt,'</small>
      </td>
   </tr>
   <tr>
      <td>
      &nbsp;<small>',$str[62],'</small>
      </td>
      <td align="center">
      &nbsp;<input type="submit" class="buttons" value="',$str[61],'" name="submit">
      </td>
   </tr>
   <tr>
      <td>
      &nbsp;<small>',$str[66],'</small>
      </td>
      <td align="center">
      &nbsp;<input type="submit" class="buttons" value="',$str[60],'" name="submit">
      </td>
   </tr>
   <tr>
      <td>
      </td>
   </tr>
</table>
<br>',"\n";
        if (count($data) > 0) {
            echo '<table width="98%" align="center" cellpadding="4" cellspacing="4">';

echo '   <tr>',"\n";
if ($action_dsp != '') {
    echo '      <td class="tables1" width="20%">
      &nbsp;
      </td>
      <td align="center" width="20%" class="tables3">
      <font class="font2"><small>',$action_dsp,'</small></font>
      </td>
      <td  nowrap align="right" class="tables1">';
}
else {
    echo '      <td colspan="3" nowrap align="right" class="tables1">';
}
echo '      <input class="button4" type="submit" name="toggle_all" ', 
         'value="',$str[246],'">&nbsp;&nbsp;
      <input type="hidden" name="id" value="',$hm_input['id'],'">
      <input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'">
      &nbsp;&nbsp;<select name="selection_type" class="select3">
          <option class="option3" value="marked">',$str[6],'</option>';
if (!empty($data)) {
    $fold_tmp = array_keys($data);
    $fold_tmp_dsp = hm_folder_dsp($fold_tmp);
    foreach ($fold_tmp as $val) {
        echo '<option class="option3" value="',$val,'">',$str[51],' ',$fold_tmp_dsp[$val],
             '</option>',"\n";
    }
}
echo '          <option class="option3" value="page">',$str[52],'</option>
      </select>&nbsp;
      <input type="submit" class="button4" name="action" value="',$str[2],'">
      <input type="submit" class="button4" name="action" value="',$str[3],'">
      <input type="submit" class="button4" name="action" value="',$str[4],'">
      &nbsp;<input type="submit" class="button4" name="action" value="',$str[1],'">-<input type="submit" class="button4" name="action" value="',$str[0],'">--&gt;
      <select class="select3" name="destination">',"\n";
    hm_folder_options($dest, false, $simple, false, 'class="option3"');
    echo '      </select>&nbsp;&nbsp;
      </td>
   </tr>
   <tr>
      <td>
      </td>
   </tr>
</table>
<table width="99%" align="center" cellpadding="1" cellspacing="0" class="tables5">
   <tr class="tables0">
      <td width="30%" align="center">
      <small>
      ',$str[21],'
      </small>
      </td>
      <td width="30%" align="center">
      <small>
      ',$str[22],'
      </small>
      </td>
      <td align="center" width="30%" colspan="2">
      <small>
      ',$str[23],'
      </small>
      </td>
   </tr>
   <tr class="tables0">
      <td colspan="4">
      <table width="99%" align="center" cellpadding="1" cellspacing="1" class="tables5">',
      "\n";
        $current = false;
        foreach($data as $folder => $uid_array) {
            if ($folder == $hm_input['mailbox']) {
                $current = true;
            }
            echo '         <tr>
            <td>
            <table cellpadding="1" cellspacing="0" width="100%">
               <tr>
                  <td width="20%" nowrap>
                  &nbsp;
                  <a class="font2" href="mailbox.php?mailbox=',urlencode($folder),
                  '&amp;id=',$hm_input['id'],'">
                  <b><small>',htmlspecialchars($_SESSION['dsp_folders'][$folder], 
                  ENT_QUOTES, $str['charset']),'
                  </small></b>
                  </a>
                  <font class="font2"><small><small>
                  &nbsp;(',count($uid_array),')&nbsp;
                  </small></small></font>
                  </td>
                  <td class="tables5">
                  </td>
               </tr>
            </table>
            </td>
         </tr>',"\n";
        $chk_folder = base64_encode('fold_'.$folder);
        foreach ($uid_array as $uid => $headers) {
            if (!isset($headers[0]) || trim($headers[0]) == '') {
                $subject = $str[229];
            }
            else {
                $subject = $headers[0];
            }
            if (!isset($headers[1]) || trim($headers[1]) == '') {
                $from = $str[230];
            }
            else {
                $headers[1] = ltrim(str_replace('&quot;', '', $headers[1]));
                if (substr($headers[1], 0, 4) != '&lt;') {
                    $headers[1] = preg_replace("/&lt;.*&gt;/", '', $headers[1]);
                }
                else {
                    $headers[1] = str_replace(array('&lt;', '&gt;'), '', $headers[1]);
                }
                $from = $headers[1];
            }
            if (!isset($headers[2]) || trim($headers[2]) == '') {
                $headers[2] = $str[231];
            }
            if (isset($headers[4]) && 
                                      (stristr($headers[4], 'multipart') || 
                                       stristr($headers[4], 'mixed'))) {
                $headers[4] = "<b><small>&nbsp;+</small></b>\n";
            }
            else {
                $headers[4] = '';
            }
            if (isset($headers[5]) && !stristr($headers[5], 'seen')) {
                $class = 'tables6';
                $font = 'font2';
                $new = 1;
            }
            else {
                $class = 'tables2';
                $font = 'font1';
                $new = 0;
            }
            $tag = 'uid='.$uid.'&amp;mailbox='.urlencode($folder).'&amp;id='.
                   urlencode($hm_input['id']).'&amp;new='.$new.'&amp;search=1';

            echo '          <tr class="',$class,'">
             <td width="50%" class="',$class,'">
             <table width="100%" cellpadding="0" cellspacing="0">
             <tr>
             <td width="1%" nowrap>
             <input type="checkbox" name="',$chk_folder,'[]" value="',$uid,'" ';
            if (isset($hm_input['toggle_all'])) {
                if (!isset($_POST[$chk_folder])) {
                    echo 'CHECKED ';
                }
                else {
                    if (!in_array($uid, $_POST[$chk_folder])) {
                    echo 'CHECKED ';
                    }
                }
            }
            echo '>&nbsp;
             </td>
             <td>',"\n";
            if (isset($hm_input['uid']) && $uid == $hm_input['uid'] && $current) {
                echo '             -> ';
                $current = false;
            }
            else {
                echo '             &nbsp;&nbsp;&nbsp; ';
            }
            echo '             <small><a class="',$font,'" href="message.php?',$tag,'">
             ',$subject,'
             </a> </small>
             </td>
             </tr>
             </table>
             </td>
             <td width="35%" class="',$class,'">
             <small><a class="',$font,'" href="message.php?',$tag.'">
             ',$from,'
             </a></small>
             </td>
             <td width="14%" class="',$class,'">
             <small><a class="',$font,'" href="message.php?',$tag,'">
             ',htmlspecialchars($headers[2], ENT_QUOTES, $str['charset']),'
             </a></small>
             </td>
             <td class="tables5" width="1%" align="center" class="',$class,'">
             ',$headers[4],'
             </td>
         </tr>',"\n";
            }
        }
        echo '         <tr>
            <td>
            &nbsp;
            </td>
         </tr>
      </table>
      </td>
   </tr>
   <tr>
      <td colspan="4" class="tables0">
      &nbsp;
      </td>
   </tr>
</table>';
        }
        else {
            echo '<br><table align="center" class="tables3">
   <tr>
      <td align="center">
      <font class="font2"><small>
      No messages found that match your search
      </small></font>
      </td>
   </tr>
</table>';
    }
}

$months = $str['months'];

echo '<br>
<input type="hidden" name="id" value="',$hm_input['id'],'">
<input type="hidden" name="mailbox" value="',$hm_input['mailbox'],'">
<table class="tables5" cellpadding="4" cellspacing="4" align="center">
   <tr>
      <td rowspan="3">
      <table class="tables0" width="99%" cellspacing="1" cellpadding="2">
         <tr class="tables1">
            <td align="center">
            ',$str[55],'
            </td>
         </tr> 
         <tr>
            <td>
            <br>
            </td>
         </tr>
         <tr>
            <td nowrap align="center">
            &nbsp;&nbsp;<select name="search_folders[]" multiple size="20">',"\n";
    hm_folder_options($search_folder, false, $simple, false);
    echo '                  </select>&nbsp;&nbsp;
            </td>
         </tr>
         <tr>
            <td>
            <br>
            </td>
         </tr>
      </table> 
      </td>
      <td valign="top" height="10%">
      <table class="tables0" width="99%" cellspacing="1" cellpadding="2">
         <tr class="tables1">
            <td align="center" colspan="4">
            ',$str[56],'
            </td>
         </tr> 
         <tr>
            <td>
            <br>
            </td>
         </tr>
         <tr>
            <td align="center" nowrap>
            <small>',$str[44],'</small>
            </td>
            <td align="center" colspan="3">
            <small>',$str[23],'</small>
            </td>
         </tr> 
         <tr>
            <td nowrap>
            &nbsp;
            <select name="range_type">
               <option ';
if ($range_type == 'any') {
    echo 'SELECTED ';
}
echo 'value="any">',$str[76],'</option>
               <option ';
if ($range_type == 'SENTBEFORE') {
    echo 'SELECTED ';
}
echo 'value="SENTBEFORE">',$str[77],'</option>
               <option ';
if ($range_type == 'SENTSINCE') {
    echo 'SELECTED ';
}
echo 'value="SENTSINCE">',$str[78],'</option>
               <option ';
if ($range_type == 'SENTON') {
    echo 'SELECTED ';
}
echo 'value="SENTON">',$str[79],'</option>
            </select>
            &nbsp;&nbsp;
            </td>
            <td>
               <select name="month">',"\n";
foreach ($months as $key => $val) {
    echo '             <option ';
    if ($key == $month) {
        echo 'SELECTED ';
    }
    echo 'value="',$key,'">',$val,"</option>\n";
}
echo '                </select>
            </td>
            <td>
               <select name="day">',"\n";
for ($i=1;$i<32;$i++) {
    echo '            <option ';
    if ($i == $day) {
        echo 'SELECTED ';
    }
    echo 'value="',$i,'">',$i,"</option>\n";
} 
echo '               </select>
            </td>
            <td nowrap>
               <select name="year">',"\n";
for ($i=1970;$i<2010;$i++) {
    echo '            <option ';
    if ($i == $year) {
        echo 'SELECTED ';
    }
    echo ' value="',$i,'">',$i,"</option>\n";
} 
echo '               </select>
            &nbsp;
            </td>
         </tr>
         <tr>
            <td>
            <br>
            </td>
         </tr>
      </table>
      </td>
      <td valign="top" rowspan="2">
      <table class="tables0" width="99%" cellspacing="1" cellpadding="2">
         <tr class="tables1">
            <td align="center" colspan="2">
            ',$str[57],'
            </td>
         </tr> 
         <tr>
            <td>
            <br>
            </td>
         </tr>
         <tr>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_ANSWERED'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_ANSWERED">&nbsp;',$str[67],'
            </td>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_UNANSWERED'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_UNANSWERED">&nbsp;',$str[68],'
            </td>
         </tr> 
         <tr>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_SEEN'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_SEEN">&nbsp;',$str[2],'
            </td>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_UNSEEN'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_UNSEEN">&nbsp;',$str[3],'
            </td>
         </tr> 
         <tr>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_DELETED'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_DELETED">&nbsp;',$str[89],'
            </td>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_UNDELETED'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_UNDELETED">&nbsp;',$str[70],'
            </td>
         </tr> 
         <tr>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_FLAGGED'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_FLAGGED">&nbsp;',$str[71],'
            </td>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_UNFLAGGED'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_UNFLAGGED">&nbsp;',$str[72],'
            </td>
         </tr> 
         <tr>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_DRAFT'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_DRAFT">&nbsp;',$str[69],'
            </td>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_UNDRAFT'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_UNDRAFT">&nbsp;',$str[73],'
            </td>
         </tr> 
         <tr>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_RECENT'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_RECENT">&nbsp;',$str[74],'
            </td>
            <td>
            <input type="checkbox" ';
if (isset($hm_input['FLAG_OLD'])) {
    echo 'CHECKED ';
}
echo 'name="FLAG_OLD">&nbsp;',$str[75],'
            </td>
         </tr> 
         <tr>
            <td>
            <br>
            </td>
         </tr>
      </table>
      </td>
   </tr>
   <tr>
      <td valign="top" height="10%">
      <table class="tables0" width="99%" cellspacing="1" cellpadding="2">
         <tr class="tables1">
            <td align="center" colspan="3">
            ',$str[24],'
            </td>
         </tr> 
         <tr>
            <td align="center" nowrap>
            <small>',$str[44],'</small>
            </td>
            <td align="center" nowrap>
            <small>',$str[24],'</small>
            </td>
         </tr>
         <tr>
            <td>
            &nbsp;
            <select name="size_type">
               <option ';
if ($size_type == 'any') {
    echo 'SELECTED ';
}
echo 'value="any">',$str[76],'</option>
               <option ';
if ($size_type == 'SMALLER') {
    echo 'SELECTED ';
}
echo 'value="SMALLER">',$str[80],'</option>
               <option ';
if ($size_type == 'LARGER') {
    echo 'SELECTED ';
}
echo 'value="LARGER">',$str[81],'</option>
            </select>
            </td>
            <td>
            &nbsp;<input type="text" size="10" class="text2" name="size" value="',
            htmlspecialchars($size, ENT_QUOTES, $str['charset']),'">&nbsp;
            </td>
            <td>
            <select name="size_unit">
               <option ';
if ($size_unit == 'b') {
    echo 'SELECTED ';
}
echo 'value="b">',$str[82],'</option>
               <option ';
if ($size_unit == 'k') {
    echo 'SELECTED ';
}
echo 'value="k">',$str[83],'</option>
               <option ';
if ($size_unit == 'm') {
    echo 'SELECTED ';
}
echo 'value="m">',$str[84],'</option>
            </select>
            </td>
         </tr> 
         <tr>
            <td>
            <br>
            </td>
         </tr>
      </table>
      </td>
   </tr>
   <tr>
      <td nowrap colspan="2" valign="top">
      <table>
         <tr>
            <td rowspan="2">
            <table class="tables0" cellspacing="1" cellpadding="2">
               <tr class="tables1">
                  <td valign="top" align="center">
                  ',$str[58],'
                  </td>
               </tr> 
               <tr>
                  <td>
                  <br>
                  </td>
               </tr>
               <tr>
                  <td nowrap>
                  &nbsp;
                  <textarea cols="60" name="sstring" class="text2" rows="4">',
                  htmlspecialchars($sstring, ENT_QUOTES, $str['charset']),'</textarea>
                  &nbsp;
                  </td>
               </tr> 
               <tr>
                  <td>
                  <br>
                  </td>
               </tr>
            </table>
            </td>
            <td rowspan="2">
            &nbsp;
            </td>
            <td valign="top" nowrap height="5%">
            <table class="tables0" cellspacing="1" cellpadding="2">
               <tr class="tables1">
                  <td align="center">
                  ',$str[59],'
                  </td>
               </tr> 
               <tr>
                  <td>
                  <br>
                  </td>
               </tr>
               <tr>
                  <td align="center" nowrap>
                  &nbsp;
                  <select name="search_part">
                     <option ';
if ($search_part == 'TEXT') {
    echo 'SELECTED ';
}
echo 'value="TEXT">',$str[85],'</option>
                     <option ';
if ($search_part == 'FROM') {
    echo 'SELECTED ';
}
echo 'value="FROM">',$str[22],'</option>
                     <option ';
if ($search_part == 'TO') {
    echo 'SELECTED ';
}
echo 'value="TO">',$str[25],'</option>
                     <option ';
if ($search_part == 'CC') {
    echo 'SELECTED ';
}
echo 'value="CC">',$str[87],'</option>
                     <option ';
if ($search_part == 'BCC') {
    echo 'SELECTED ';
}
echo 'value="BCC">',$str[88],'</option>
                     <option ';
if ($search_part == 'SUBJECT') {
    echo 'SELECTED ';
}
echo 'value="SUBJECT">',$str[21],'</option>
                     <option ';
if ($search_part == 'BODY') {
    echo 'SELECTED ';
}
echo 'value="BODY">',$str[86],'</option>
                  </select>
                  &nbsp;
                  </td>
               </tr> 
               <tr>
                  <td>
                  <br>
                  </td>
               </tr>
            </table>
            </td>
         </tr>
         <tr>
            <td align="center">
            <br>
            &nbsp;<input type="submit" class="button2" value="',$str[11],'" name="submit">
            <br><br>
            &nbsp;<input type="submit" class="button2" value="',$str[60],'" name="submit">
            </td>
         </tr>
      </table>
      </td>
   </tr>
</table>
</form>',"\n";

echo '</body>
</html>';

hm_imap_logout($imap_stream); 

?>
