<?php

/* html_functions.php: Some functions for html generation 
*
    Copyright (C) 2002  Hastymail Development group

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; Version 2
    See the COPYING file for complete information.

* $Id: html_functions.php,v 1.154 2003/10/21 17:19:38 sailfrog Exp $
*/


/* function to print out folder option elements for select boxes
    $mailbox = currently selected mailbox (can be an array of boxes for multiselect)
    $unseen  = unseen data array, or false to not display unseen counts
    $simple  = simple display mode
    $enc     = if true option values are urlencoded
    $style   = css style to use for the option elements
    returns nothing
*/ 
function hm_folder_options($mailbox, $unseen=false, $simple=false, $enc=false, 
                           $style='') {
    $delim = $_SESSION['delimiter'];
    $folders = $_SESSION['folders'];
    $dsp_folders = $_SESSION['dsp_folders'];
    $no_sel = $_SESSION['nosel_folders'];
    foreach($folders as $folder) {
        echo '                  <option ',$style,' value="';
        if ($enc) {
            echo urlencode($folder);
        }
        else {
            echo $folder;
        }
        if (in_array($folder, $no_sel)) {
            echo ' " DISABLED >';
        }
        elseif (!is_array($mailbox) && 
                (urlencode($folder) == $mailbox || $folder == $mailbox)) {
            echo '" SELECTED >';
        }
        elseif (is_array($mailbox) && in_array($folder, $mailbox)) {
            echo '" SELECTED >';
        }
        else {
            echo '">';
        }
        if ($unseen && !isset($unseen[$folder])) {
            $unseen[$folder] = 0;
        }
        if ($unseen) {
            echo $unseen[$folder],"   ";
        } 
        if (!$simple && substr_count($dsp_folders[$folder], $delim) > 0) {
            $pos = strrpos($dsp_folders[$folder], $delim);
            echo str_repeat('&nbsp;', intval($pos/2)),'|_ ',substr($dsp_folders[$folder],
                 ($pos + 1)),"\n";
        }
        else {
            echo $dsp_folders[$folder],"</option>\n";
        }
    }
}

/* function to output the top of each page, html title etc. and the toolbar
   $imap_stream = conneciton to imap
   $mailbox     = currently selected folder
   $unseen      = unseen array
   $refresh     = if true will output a page refresh meta tag (for the new mail page)
   returns nothing
*/
function hm_toolbar($imap_stream, $mailbox, $unseen, $refresh=false, $page_name=false) {
    $config = $_SESSION['config'];
    $settings = $_SESSION['settings'];
    $str = $_SESSION['str'];
    if (isset($settings['simple']) && $settings['simple'] == 'true') {
        $simple = true;
    }
    else {
        $simple = false;
    }
    if (!isset($settings['css_file'])) {
        $settings['css_file'] = 'default.css';
    }
    if (isset($settings['refresh_new'])) {
        $refresh_new = $settings['refresh_new'] * 60;
    }
    else { 
        $refresh_new = 60;
    }
    if (isset($config['page_title'])) {
        $title = $config['page_title'].' | ';
    }
    else {
        $title = 'Hastymail | ';
    }
    if ($page_name) {
        $title .= $page_name.' | ';
    }
    $total = 0;
    foreach ($unseen as $index => $value) {
        $total += $value;
    }

    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT"); 
    header("Cache-Control: no-store, no-cache, must-revalidate");
    header("Cache-Control: post-check=0, pre-check=0", false);
    header("Pragma: no-cache");             
    header("Content-Type: text/html; charset=".$str['charset']);

    echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <title>
      ',$title,'  ',$total,' ',$str[10],'
  </title>
  <meta HTTP-EQUIV="content-type" CONTENT="text/html; charset=',$str['charset'],'">',"\n";
    if ($refresh && ($refresh_new != 0)) {
        echo '  <meta HTTP-EQUIV="refresh" content="',$refresh_new,';url=',
            $config['hostname'],$config['install_path'],
            'new.php?mailbox=',urlencode($mailbox),'&amp;id=',session_id(),"\">\n";
    }
    if (!$simple) {
        echo '  <link rel="stylesheet" type="text/css" href="../themes/',
             $settings['css_file'],"\" >\n";
    }
    echo '<link rel="SHORTCUT ICON" href="../images/hastymail.ico">
</head>
<body>',"\n";
    if (!$simple) {
    echo '<table width="100%" align="center">
   <tr>
      <td class="tables1" width="1%">
      <table align="center" width="100%" cellpadding="2" cellspacing="2" class="tables0">
         <tr>
            <td align="center" valign="middle" width="29">
            <a href="about.php?id=',session_id(),'">
            <img src="../images/hastymail.png" width="28" height="23" border="0" alt="H">
            </a>
            </td>
            <td align="center" nowrap valign="middle">',"\n";
    }
    echo '             <form action="mailbox.php" method="post">
            <select name=mailbox>',"\n";
    hm_folder_options($mailbox, $unseen, $simple, true);
    echo '            </select>
            &nbsp;&nbsp;
            <input type="submit" name="',$str[5],'" value="',$str[5],'" class="button2">
            <input type="hidden" name="id" value="',session_id(),'">
            </form>',"\n";
    if (!$simple) {
    echo '            </td>
            <td align="right" nowrap>',"\n";
        $search = '<input type="submit" name="search" value="'.$str[11].
                  '" class="buttons">';
    }
    else {
        $search = '';
    }
    echo '            <form method="post" action="redirect.php">
            <input type="submit" name="new" value="',$total,' ',$str[10],
            '" class="buttons">
            ',$search,'
            <input type="submit" name="options" value="',$str[12],'" class="buttons">
            <input type="submit" name="folders" value="',$str[13],'" class="buttons">
            <input type="submit" name="contacts" value="',$str[14],'" class="buttons">
            <input type="submit" name="compose" value="',$str[15],'" class="buttons">
            <input type="submit" name="logout" value="',$str[16],'" class="buttons">
            <input type="hidden" name="id" value="',session_id(),'">
            <input type="hidden" name="mailbox" value="',$mailbox,'">
            <input type="hidden" name="hostname" value="',$config['hostname'],'">
            <input type="hidden" name="install_path" value="',$config['install_path'],'">
            </form>',"\n";
    if (!$simple) {
echo '            </td>
        </tr>
    </table>
    </td>
</tr>
</table>',"\n";
        if (isset($config['iframe']) && $config['iframe'] == 'true' && 
           (!$refresh || $refresh_new == 0)) {
            echo '<iframe src="iframe.php?id=',session_id(),
         '" width="0" height="0" frameborder="0" style="{display: none}">
Imbedded frame to keep your connection to hastymail active
</iframe>',"\n";
        }
    }
    hm_print_error($simple);
}

/* check for errors and print them out 
    $simple = status of simple mode display
   for now this function only checks for folder list errors and
   prints them under the toolbar
*/
function hm_print_error($simple) {
    $str = $_SESSION['str'];

    /* folder list errors */
    if (isset($_SESSION['missing_folders_flag']) && 
        $_SESSION['missing_folders_flag'] == 1) {
        if ($simple) {
            if (isset($_SESSION['error'])) {
                echo $_SESSION['error'],'<br>',$str[47],'<br>';
            }
            $_SESSION['error'] = '';
            unset($_SESSION['error']);
        }
        else {
            echo '<br><table align="center" class="tables3">
   <tr>',"\n";
            if (isset($_SESSION['error'])) {
                echo '     <td colspan="2" align="center">
       ',$_SESSION['error'],'
      </td>
   </tr>
   <tr>',"\n";
                $_SESSION['error'] = '';
                unset($_SESSION['error']);
            }
            echo '      <td>
      ',$str[48],'
      </td>
      <td>',"\n";
        }
        foreach ($_SESSION['missing_folders'] as $missing) {
            echo " <b>$missing</b>";
        }
        if (!$simple) {
            echo '      </td>
   </tr>
   <tr>
      <td colspan="2" align="center">
      ',$str[49],'
      </td>
   </tr>
</table>',"\n";
        }
        $_SESSION['missing_folders_flag'] = 0;
        unset($_SESSION['missing_folders_flag']);
    }
}




/* function to print out the attachments part of the message page
   $structure = the message structure array
   $part      = message part number
   $atag      = the begining of a really long link tag
   $level     = keeps track of recursive calling for part indentation
   returns nothing
*/
function hm_print_attachments ($structure, $part, $atag, $level=0) {
    $simple = false;
    $str = $_SESSION['str'];
    if (isset($_SESSION['settings']['simple']) &&
              $_SESSION['settings']['simple'] == 'true') {
        $simple = true;
    }
    $types = array( 'textplain', 'messagedisposition-notification', 
                    'messagedelivery-status', 'imagejpeg', 'imagepjpeg', 
                    'imagejpg', 'imagepng', 'imagegif', 'texthtml', 'textenriched');

    foreach ($structure as $index => $array) {
        $double_link = false;
        if (!isset($array['type'])) {
            $type = 'unknown';
        }
        else {
            $type = $array['type'];
        }
        if (!isset($array['subtype'])) {
            $subtype = 'unknown';
        }
        else {
            $subtype = $array['subtype'];
        }

        /* normal attachments */
        if ($type != 'mixed' && $type != 'unknown' && $subtype != 'rfc822') {
            if (!$simple) {
            echo '         <tr class=';
            if ($index == $part) {
                echo '"tables4"';
            }
            else {
                echo '"tables3"';
            }
            echo ">\n",
                 '            <td align="center" nowrap>
            <small>',"\n";
            }
            else {
                echo '<br><small>';
            }

            /* view links for supported types */
            if (in_array($type.$subtype, $types) && $index != $part) {
                echo $atag,"part=$index\">",$str[39],"</a></small>\n";
                $double_link = true;
            }

            /* download links for supported types */
            if ($type != 'message') {
                if ($double_link) {
                    echo ' | <small>';
                }
                echo '            ',
                     preg_replace("/message.php/", 'download.php', $atag),
                     "part=$index";
                if ($double_link || $index == $part) {
                    echo '&amp;subtype=octet-stream&amp;type=application';
                }
                else {
                    echo '&amp;subtype=',$subtype,'&amp;type=',$type;
                }
                if ($type.$subtype == 'textplain' || $type.$subtype == 'textenriched') {
                    echo "&amp;name=message.txt";
                }
                elseif ($type.$subtype == 'texthtml') {
                    echo '&amp;name=message.html';
                }
                elseif (preg_match("/\"filename\" \"([^\"]+)\"/i", $array['remainder'],
                                   $matches)) {
                   echo '&amp;name=',urlencode($matches[1]);
                }
                elseif (isset($array['name']) && trim($array['name']) != '') {
                    echo "&amp;name=", urlencode($array['name']);
                }
                else {
                    echo '&amp;name=unknown.',$subtype;
                }
                if (isset($array['encoding']) && isset($array['encoding'])) {
                    echo '&amp;decode=',strtolower($array['encoding']);
                }
                echo '">',$str[38],'</a>
            </small>',"\n";
                if (!$simple) {
                    echo '            </td>',"\n";
                }
            }

            /* indent and type section */
            if (!$simple) {
                echo '            <td nowrap>',"\n";
            }
            echo '            <small>&nbsp;', str_repeat('&nbsp;', ($level*8));
            if ($level > 0) {
                echo '|_&nbsp;';
            }
            echo $type,' - ',$subtype,' </small>',"\n";
            if (!$simple) {
                echo '             </td>',"\n";

            /* description */
            echo '            <td nowrap>',"\n";
            }
            echo '            <small>',"\n";
            if (isset($array['description']) && 
                strtolower($array['description']) != 'nil' &&
                trim($array['description']) != '') {
                echo '            ',str_replace('"', '', $array['description']),"\n";
            }
            elseif (isset($array['subject']) && 
                strtolower($array['subject']) != 'nil' &&
                trim($array['subject']) != '') {
                echo '            ', $array['subject'],"\n";
            }
            elseif (isset($array['name']) && trim($array['name']) != '') {
                    echo "            ", $array['name'],"\n";
            }

            /* size */
            echo '            </small>',"\n";
            if (!$simple) {
                echo '            </td>
            <td align="center" nowrap>',"\n";
            }
            echo "            <small>\n";
            if (isset($array['size'])) {
                echo '            ',$array['size'],"\n";
            }
            else {
                echo "            Unknown\n";
            }
            echo "            </small>\n";
            if (!$simple) {
                echo "            </td>
         </tr>\n";
            }
        }

        /* rfc822 messages */
        if ($type == 'message' && $subtype == 'rfc822') {
            if (!$simple) {
                echo '         <tr class="tables3">
            <td>
            </td>
            <td>
            <small>
            ',str_repeat('&nbsp;', ($level*8)),'&nbsp;Rfc-message:&nbsp;&nbsp;&nbsp;
            </small>
            </td>
            <td colspan="2">
            <table width="100%">
               <tr>
                 <td width="60%">
                 <small>',"\n";
            }
            else {
                echo "<small>\n";
            }
            if (isset($array['description']) && 
                strtolower($array['description']) != 'nil') {
                echo '                 ',str_replace('"', '', $array['description']),"\n";
            }
            elseif (isset($array['subject']) && 
                strtolower($array['subject']) != 'nil') {
                echo '                 ',$array['subject'],"\n";
            }
            echo '                   </small>',"\n";
            if (!$simple) {
                echo '                   </td>
                  <td width="40%">',"\n";
            }
            echo '                   <small>',"\n";
            if (isset($array['from']) && 
                strtolower($array['from']) != 'nil') {
                echo '                 ',str_replace('"', '', $array['from']),"\n";
            }
            echo '                   </small>',"\n";
            if (!$simple) {
                echo '                   </td>
                </tr>
             </table>
             </td>
          </tr>',"\n";
            }
        }
                 
        if (isset($array['subs'])) {
            if (isset($level)) {
                $level += 1;
            }
            hm_print_attachments ($array['subs'], $part, $atag, $level);
            $level -= 1;
        }
    }
}
/* function to build the first 2/3 of the top and bottom of the message page
   $sort_info   = the sort information for this mailbox
   $mailbox     = the currently selected folder
   $imap_stream = connection to imap
   $page_num    = the current page number if known
   $id          = session id
   $uid         = message uid
   returns a 2 part array. part 1 is the html and part two is an indicator
   to adjust the prev/next message links
*/
function hm_message_header ($sort_info, $mailbox, $imap_stream, 
                            $page_num, $id, $uid, $dsp_folders, $smaller=false,
                            $simple=false) {
    $pre = false;
    $nex = false;
    $string = false;
    $pre_new = false;
    $nex_new = false;
    $key = array_keys($sort_info[2], $uid);
    $key = $key[0];
    $result = '';
    $str = $_SESSION['str'];

    if (!in_array($uid, $sort_info[1][$page_num][2])) {
        if (isset($sort_info[1][$page_num + 1][2]) &&
            in_array($uid, $sort_info[1][$page_num + 1][2])) {
            $page_num = $page_num + 1;
        }
        elseif (isset($sort_info[1][$page_num - 1][2]) &&
                in_array($uid, $sort_info[1][$page_num - 1][2])) {
            $page_num = $page_num - 1;
        }
        else {
            foreach ($sort_info[1] as $index => $array) {
                if (in_array($uid, $array[2])) {
                    $page_num = $index;
                    break;
                }
            }
        }
    }
    if (!$simple) {
        $result .= '         <tr>
            <td class="tables4" width="10%" align="center" nowrap>&nbsp;'."\n";
    }

    /* pevious and next links */
    if (isset($sort_info[2][$key - 1])) {
        $pre = $sort_info[2][$key - 1];
        $string = trim($pre);
    }
    if (isset($sort_info[2][$key + 1])) {
        $nex = $sort_info[2][$key +1];
        if ($string) {
            $string .= ','.trim($nex);
        }
        else {
            $string = trim($nex);
        }
    }    
    $headers = hm_get_messages ($string, $imap_stream);
    if ($pre) {
        if (!stristr($headers[$pre][5], 'seen')) {
            $new = 1;
            $pre_new = 1;
            $font_style = 'font3';
        }
        else {
            $new = 0;
            $font_style = 'font2';
        }
        $result .= '            <a class="'.$font_style.'" href="message.php?'.
                'mailbox='.urlencode($mailbox).'&amp;uid='.urlencode($pre).
                '&amp;id='.$id.'&amp;new='.$new.'&amp;page_num='.$page_num.'">
            &lt;&lt;&lt;</a>&nbsp;&nbsp;&nbsp;'."\n";
    }
    if ($nex) {
        if (!stristr($headers[$nex][5], 'seen')) {
            $new = 1;
            $nex_new = 1;
            $font_style = 'font3';
        }
        else {
            $new = 0;
            $font_style = 'font2';
        }
        $result .= '            <a class="'.$font_style.'" href="message.php?'.
                'mailbox='.urlencode($mailbox).'&amp;uid='.urlencode($nex).
                '&amp;id='.$id.'&amp;new='.$new.'&amp;page_num='.$page_num.'">
            &gt;&gt;&gt;</a>'."\n";
    }

    /* link back to the mailbox page, with page number */
    if (!$simple) {
        $result .= '            &nbsp;
            </td>
            <td class="tables1" ';
        if ($smaller) {
            $result .= 'width="30%"';
        }
        else {
            $result .= 'width="80%"';
        }
        $result .= ' align="left">'."\n";
    }
    $result .= '            <a class="font2" href="mailbox.php?mailbox='.
            urlencode($mailbox).'&amp;id='.$id.'&amp;page_num='.$page_num.'">
            &nbsp;&nbsp;'.$dsp_folders[urldecode($mailbox)].' '.$str[9].'  '.
            ($page_num + 1).'</a>';
    
    return array($result, $pre, $nex, $pre_new, $nex_new);
}

?>
