<?php

/* imap_3.php: More IMAP functions
*
    Copyright (C) 2002  Hastymail Development group

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; Version 2
    See the COPYING file for complete information.

* $Id: imap_3.php,v 1.17 2003/10/17 20:33:29 sailfrog Exp $
*/


/* get IMAP capability response
   $imap_stream = connection to the imap server
   returns the imap CAPABILITY response or an error string
*/
function hm_get_caps($imap_stream) {
    $str = $_SESSION['str'];
    $_SESSION['counter']++;
    $pre = 'A000'.$_SESSION['counter'];
    $pre_len = strlen($pre);
    $result = array();
    $command = "$pre CAPABILITY\r\n";
    $n = -1;
    $caps_string = $str[200];
    fputs($imap_stream, $command);
    do {
        $n++;
        $result[$n] = fgets($imap_stream, 1024);
        if (stristr($result[$n], '* CAPABILITY')) {
            $caps_string = $result[$n];
        }
    } while (substr($result[$n], 0, $pre_len) != $pre);
    return $caps_string;
}

/* delete an imap folder
   $folder       = folder to delete
   $imap_stream  = conneciton to imap
   $settings_dir = the location of the users settings file
   returns $return string which indicates if the operation was successful
*/
function hm_delete_folder ($folder, $imap_stream, $settings_dir) {
    $str = $_SESSION['str'];
    $_SESSION['counter']++;
    $pre = 'A000'.$_SESSION['counter'];
    $pre_len = strlen($pre);
    $return_1 = "<br><table align=\"center\" class=\"tables3\">\n".
                "   <tr>\n".
                "      <td align=\"center\">\n".
                "      <font class=\"font2\"><small>\n";
    $return_3 = "      </small></font>\n".
                "      </td>\n".
                "   </tr>\n".
                "</table>\n";
    $command = "$pre DELETE \"$folder\"\r\n";
    fputs($imap_stream, $command);
    $result = fgets($imap_stream, 1024);
    if (preg_match("/^$pre (NO|BAD)/", $result)) {
        $return_2 = $str[201].":<br>".
                    $result."\n";
    }
    elseif (preg_match("/^$pre OK/", $result)) {
        $update_settings = false;
        if (isset($_SESSION['settings']['sort'][urlencode($folder)])) {
            unset($_SESSION['settings']['sort'][urlencode($folder)]);
            $update_settings = true;
        }
        if (isset($_SESSION['settings']['hidden']) && 
            is_array($_SESSION['settings']['hidden'])) {
            foreach($_SESSION['settings']['hidden'] as $index => $mailbox) {
                if ($mailbox == $folder) {
                    unset($_SESSION['settings']['hidden'][$index]); 
                    $update_settings = true;
                    break;
                }
            }
        }
        if ($update_settings) {
            hm_write_settings($_SESSION['user'], $settings_dir);
        }
        $return_2 = $str[202]."\n";
    }
    else {
        $return_2 = $str[203].":<br>".
                    $result."\n";
    }
    return $return_1.$return_2.$return_3;
}

function hm_rename_folder ($old_folder, $imap_stream, $new_folder, $settings_dir) {
    $str = $_SESSION['str'];
    $_SESSION['counter']++;
    $pre = 'A000'.$_SESSION['counter'];
    $pre_len = strlen($pre);
    $delim = $_SESSION['delimiter'];
    $prefix = strrev(strstr(strrev($old_folder), $delim));
    $return_1 = "<br><table align=\"center\" class=\"tables3\">\n".
                "   <tr>\n".
                "      <td align=\"center\">\n".
                "      <font class=\"font2\"><small>\n";
    $return_3 = "      </small></font>\n".
                "      </td>\n".
                "   </tr>\n".
                "</table>\n";
    if ($delim == 'nil') {
        return $return_1.$str[204]."<br>".$str[205].$return_3;
    }
    else { 
        if ($prefix != '' && substr($prefix, -1) != $delim) {
            $prefix .= $delim;
        }
    }
    $command = "$pre RENAME \"$old_folder\" \"$prefix$new_folder\"\r\n";
    fputs($imap_stream, $command);
    $result = fgets($imap_stream, 1024);
    if (preg_match("/^$pre (NO|BAD)/", $result)) {
        $return_2 = $str[242].":<br>".
                  $result."\n";
    }
    elseif (preg_match("/^$pre OK/", $result)) {
        $update_settings = false;
        if (isset($_SESSION['settings']['sort'][urlencode($old_folder)])) {
            $_SESSION['settings']['sort'][urlencode($prefix.$new_folder)] =
            $_SESSION['settings']['sort'][urlencode($old_folder)];
            unset($_SESSION['settings']['sort'][urlencode($old_folder)]);
            $update_settings = true;
        }
        if (isset($_SESSION['settings']['hidden']) && 
            is_array($_SESSION['settings']['hidden'])) {
            foreach($_SESSION['settings']['hidden'] as $index => $mailbox) {
                if ($mailbox == $old_folder) {
                    unset($_SESSION['settings']['hidden'][$index]); 
                    $_SESSION['settings']['hidden'][$index] = $prefix.$new_folder;
                    $update_settings = true;
                    break;
                }
            }
        }
        if ($update_settings) {
            hm_write_settings($_SESSION['user'], $settings_dir);
        }
        $return_2 = $str[241];
    }
    else {
        $return_2 = $str[203].":<br>".
                  $result."\n";
    }
    return $return_1.$return_2.$return_3;
}
    
    
/* create an imap folder
   $folder      = folder name to create
   $imap_stream = conneciton to imap
   $parent      = the parent folder to create this folder in, false otherwise
   $allow_subs  = true if this folder should be allowed to have subfolders
   returns $returns string indicating the result of the operation
*/
function hm_create_folder ($folder, $imap_stream, $parent=false, $allow_subs=false) {
    $str = $_SESSION['str'];
    $_SESSION['counter']++;
    $pre = 'A000'.$_SESSION['counter'];
    $pre_len = strlen($pre);
    $return_1 = "<br><table align=\"center\" class=\"tables3\">\n".
                "   <tr>\n".
                "      <td align=\"center\">\n".
                "      <font class=\"font2\"><small>\n";
    $return_3 = "      </small></font>\n".
                "      </td>\n".
                "   </tr>\n".
                "</table>\n";
    $delim = $_SESSION['delimiter'];
    $bail = false;
    if (isset($_SESSION['config']['prefix'])) {
        $prefix = $_SESSION['config']['prefix'];
    }
    if (!isset($prefix) || $prefix == '')  {
        $prefix = 'INBOX';
    }
    if ($parent && $parent != 'INBOX') {
        $prefix = $parent; 
    }
    if ($delim == 'nil') {
        $return_2 = $str[204]."<br>".$str[205];
        $bail = true;
    }
    else { 
        if (substr($prefix, -1) != $delim) {
            $prefix .= $delim;
        }
    }
    if (stristr($folder, "$delim") || $folder == 'INBOX' || $folder == 'inbox') {
        $return_2 = $str[206];
        $bail = true;
    }
    if ($allow_subs == 'yes') {
        $folder .= $delim;
    }
    if ($bail) {
        return $return_1.$return_2.$return_3;
    }
    else {
        $command = "$pre CREATE \"$prefix$folder\"\r\n";
        fputs($imap_stream, $command);
        $result = fgets($imap_stream, 1024);
        if (preg_match("/^$pre (NO|BAD)/", $result)) {
            $return_2 = $str[207].":<br>".
                      $result."\n";
        }
        elseif (preg_match("/^$pre OK/", $result)) {
            $return_2 = $str[208];
        }
        else {
            $return_2 = $str[203].":<br>".
                      $result."\n";
        }
        return $return_1.$return_2.$return_3;
    }
}

/* create special folders on first login
    $imap_stream = connection to IMAP
    $config      = config vars from the hastymail.conf file
    returns nothing
*/
function hm_autocreate_folders($imap_stream, $config) {
    if (isset($_SESSION['delimiter']) && $_SESSION['delimiter'] != 'nil') {
        $delim = $_SESSION['delimiter'];
        if (isset($config['prefix'])) {
            $prefix = $config['prefix'];
        }
        if (!isset($prefix) || $prefix == '')  {
            $prefix = 'INBOX';
        }
        if (substr($prefix, -1) != $delim) {
            $prefix .= $delim;
        }
        $special_folders = array ('sent', 'trash', 'drafts');
        foreach ($special_folders as $t) {
            $exists = false;
            $r = '';
            $nosel = false;
            if (isset($config['autocreate_'.$t]) && 
                $config['autocreate_'.$t] != '') {
                if (strtoupper($config['autocreate_'.$t]) == 'INBOX') {
                    $pre = '';
                }
                else {
                    $pre = $prefix;
                }
                if (in_array($pre.$config['autocreate_'.$t], $_SESSION['folders'])) {
                    $exists = true;
                }
                if (in_array($pre.$config['autocreate_'.$t],
                    $_SESSION['nosel_folders'])) {
                    $nosel = true;
                }
                if (!$exists && !$nosel) {
                    $r = hm_create_folder($config['autocreate_'.$t],$imap_stream);
                }
                if (strstr($r, $_SESSION['str'][208]) || ($exists && !$nosel)) {
                    $_SESSION['settings'][$t.'_folder'] = 
                        $pre.$config['autocreate_'.$t];
                }
            }
        }
        $_SESSION['folders'] = hm_boxlist($imap_stream, true, 'all');
    }
}


/* save sent or draft mail to folder
   $message     = message text to save (including headers)
   $imap_stream = conneciton to imap
   returns nothing, but sets $_SESSION['error'] on failure
*/
function hm_save_message ($message, $imap_stream, $type, $multi=false, 
                          $bndry=false, $size=false) {
    $str = $_SESSION['str'];
    if ($type == 'sent') {
        $folder = 'sent_folder';
    }
    elseif ($type == 'draft') {
        $folder = 'drafts_folder';
    }
    else {
        return;
    }
    $_SESSION['counter']++;
    $pre = 'A000'.$_SESSION['counter'];
    $pre_len = strlen($pre);
    if (isset($_SESSION['settings'][$folder])) {
        if (!in_array(urldecode($_SESSION['settings'][$folder]), 
            $_SESSION['folders'])) {
            if ($type == 'sent') {
                $_SESSION['error'] = $str[28];
            }
            elseif ($type == 'draft') {
                $_SESSION['error'] = $str[209];
            }
                unset($_SESSION['settings'][$folder]);
                hm_write_settings($_SESSION['user'], $_SESSION['config']['settings_dir']);                      
                return;
        }
        if (!isset($_SESSION['settings'][$folder])) {
            return;
        }
        else {
            $message = trim($message);
            if ($type == 'sent') {
                $flags = '(\Seen)';
            }
            elseif ($type == 'draft') {
                $flags = '(\Draft \Seen)';
            }
            if ($multi) {
                $imap_size = $size;
            }
            else {
                $imap_size = strlen($message);
            }
            $command = "$pre APPEND \"".
                        urldecode($_SESSION['settings'][$folder]).'" '.$flags.' {'.
                       $imap_size."}\r\n";
            fputs($imap_stream, $command);
            $result[0] = fgets($imap_stream, 1024);
            
            if (preg_match("/^$pre (NO|BAD)/", $result[0])) {
                    $_SESSION['error'] = $str[210].":<br>\n".$result[0]."\n";
                    return;
            }
            if ($multi) {
                $size_result = hm_write_data($imap_stream, $message, $bndry);
                    if ($size != $size_result) {
                        $_SESSION['error'] = 'Could not save Sent message, we thought '.
                                             'the message was<br>'.$size.' bytes but it '.
                                             'ended up being '.$size_result;
                        return;
                    }
                fputs($imap_stream, "\r\n");
            }
            else { 
                fputs($imap_stream, $message."\r\n");
            }
            $result[1] = fgets($imap_stream, 1024);
            $i = 2;
            while (!strstr($result[$i-1], $pre)) {
                $result[$i] = fgets($imap_stream, 1024);
            }
            hm_check_errors($result[$i-1], "$pre OK", $command, true);
            if ($type == 'draft') {
                $_SESSION['error'] = $str[211];
            }
        }
    }
}

?>
